#define Version "160426"



#define Projet "18F4685_Platine_Nokia_160426_40Mhz.mcppi"
#define Source  "18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz"
//#define Debug_BMP       // printout BMP sur terminal

 // schema :   ac:schema
 
 // photo       ac:photo_realisation
 
  // Pinout  :     ac:Pinout
  
//  MyLib_Nokia_96x64.C +  MyLib_Nokia_96x64.h +
// version avec  My_24LC256_Eeprom.c + My_24LC256_Eeprom.h
 
// ----------  voir   historique.txt  --------------

// RB1 lue comme un 0 alors que l'entree est relie au +VCC par R pull-up ?
// On a Power-on Reset, RB4:RB0 are  configured as analog inputs by default and   read as 0;
// init OK, mais carte Hardware RB1 est sur PIN ..libre,  non tir au +VCC
// activation RBPU_bit=1
// modif sens action  RB1=1 => lecture RTC  RB1=0 forcage init RTC
// pas bien clair sur le numero du jour Weekday Dimanche=0 ?  lundi=1 ?

//16:17:18.671>   Lecture 16 bytes PIC EEPROM  :  BOOTLOADER 2016
//16:21:03.843> Vecteur Start Bootloader en 0x17F38=  57EF2EF0
//16:21:03.906> Adresse point d'entree Prg MikroC = 2e57 h mutiplie 2 soit 5cae  ou  23726 decimal

// TinybldWin98.exe
// problemo avc TinyBootloader 1.98: L'eeprom est limite en taille 256 maxi
// donc ne charge pas au dela pour EEPROM de 1024
//  voir si une version plus rescente de Tiny Bootloader corrige ce probleme ?

// modif bootloader Q=10MHz x 4 PLL => 40MHz speed 19200 -> 57600    speed error 0,22%
/*
Tiny Bootloaders ur PC XP
liaison COM1 avec platine 18F Nokia via rajout cable DB9F-DB9F
C:\_Mplab8\tinybldWin198.exe
 \\Asus_cm6431\_18F4685_Platine_Nokia\18F4685_Nokia_96x64_8x16_Librarie_test_2016.hex
 Connected to \\.\COM1 at 57600
  Wait 100ms
  HEX: 14 min old, INHX32,18Fcode+cfg, total=10637 bytes.
  Searching for PIC ...
  Found:18F 4685
  WRITE OK  at 19:20,   time:5.235 sec
*/

//#define Version "18-03-2016"
// revu partie ADC differente d'avec 16F
// rappel : sur la platine Nokia  mettre le stap ref 4.096V sur AN3 !
// rajout Cde RAZ Index eeprom
// modif Index relecture pour 1  xxxx au lieu de 0  xxx
// suite division par 2 bytes pour chaque Int mesure ADC
// modif DiplayDate   affiche 23 pour jour 29 sur UARTT mais OK sur LCD
// enlev conversion BCcd2dec
// DateTime[1]=Mois;ByteToStr( Mois,CRam1); UART1_Write_Text( CRam1); UART1_Write('/'); 


// config:
/*  18F4685_Q10MHz_w_PLL_40Mhz.cfgsch
CONFIG1H : $300001 : 0x0002
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x001E
CONFIG3H : $300005 : 0x0080
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x003D
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x003F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x003F
CONFIG7H : $30000D : 0x0040
 */

// gestion 24LC256
// cdes terminal
// STA<CR> start stockage sur EEprom  Index raz!
// HAL<CR> HALte sauve sur eerprom  (Index NON raz!) 
// REL<CR> Stope stockage et Relit (liste) contenu Eeprom  
// DUM<CR> dump Flash du PIC

//
//U;16;06;14;1;19;35#
//Mise a l'heure RTC

// 14-06-2014
// initialise I2C Hardware => plus d'affichage LCD !!!
// HORREUR ! le piege : c'est en I2C Software que la platine est prevue (car au depart 100% Asm)
// et RC3 RC4 sont utiliss en SPI pour le nokia .. 
// I2C SOFTWARE sur RB7=SCL et RB6=SDA
// Ne pas utiliser la biblio ADC Mickroc

 //==== Parametrage pour RS232 ====
#define FOSC D'40000000'        ; <<< frequence du quartz[Hz]  ici= 10 MHz
#define BAUD D'57600'           ; <<< vitesse du port serie [bit/sec] ici=19200
#define BAUD_ERROR D'4'; <<< erreur de vitesse [%]
#define TIMEOUT  D'10'
#define BAUD_REAL   FOSC/((D'64'-(HIGH_SPEED*D'48'))*(DIVIDER+1))

#define RS232 1
#define Nokia 0

#define Limite_Max_Flash 0x17F36
//-- compilations conditionnelles -----
#define EEPROM_PIC_1024
#define EEPROM_24LC512
#define Dump
#define Software_I2C   
#define DS1307 0xD0

#define NOIR 1

//#define EEPROM_64K_ADR 0xA0   // EEPROM 24LC512
// pins 1,2,3  Adresse bits =0  => to Gnd
// 4 = VSS= 0V=Gnd
// 7= WP = Write Protect =

// Config touches de fonction terminal VBRAY
// 16f877_platine_nokia_rs.tmf
// Hardware:
// Platine 18F4685 96Ko equipee Nokia  + I2C + 2 x PCF8574 + 24LC256 + DS1307 + DS275
// LCD nokia 3310 8 lignes de 16 car
// Q=10Mhz
// rev 16 avr 2016
//  Nokia LCD  sur sorties PORTC 18F4685
// usage de LAT au lieu de PORT
//  pin support LCD Nokia  1 .. 8  sur connecteur Blanc Platine  pins 1 .. 8

#define D_C LATC.B1
#define SCE LATC.B0
#define RES LATC.B2
#define SCK LATC.B3
#define SDI LATC.B4

// pour RTC DS1307 + PCF8574
// Software I2C  cause interference abec LCD nokia
#ifdef Software_I2C       
sbit Soft_I2C_Scl           at RB6_bit;
sbit Soft_I2C_Sda           at RB7_bit;
sbit Soft_I2C_Scl_Direction at TRISB6_bit;
sbit Soft_I2C_Sda_Direction at TRISB7_bit;
sbit INIT_RTC               at RB1_bit;
sbit INIT_RTC_Direction at TRISB1_bit;

// pour garder la syntaxe I2C Hardware
#define I2C1_Start()    Soft_I2C_Start()
#define I2C1_Wr         err=Soft_I2C_Write
#define I2C1_Stop       Soft_I2C_Stop
#define I2C1_Rd         Soft_I2C_Read
#endif
 
#define LedVerte PORTE.F0
#define LedBlanche PORTE.F1
#define LedRouge PORTE.F2
#define Pi 3.14159 // Constant Pi.
#define num_of_points 64 // Number of points to plot in a graph.

#define CLS 12
#define CR 13
#define LF 10
#define BS 8
#define TAB 9

const code char mesg0[]="MikroC 18F4685 avec Bootloader Platine paulfjujo  \r\n";
const code char mesg1[]="RTC+UART+I2C+PCF8574+24LC256+Nokia3310 Q=10Mhz x PLL=40MHz\n\r";
const code char * Messages[]={mesg0,mesg1};
//Weekday=7 pour dimanche
const code char JS[7][6] ={"Diman","Lundi","Mardi","Mercr","Jeudi","Vendr","Samed"};


 unsigned char const image_MikroE_96x64[768] = {
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe0, 0x0f, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xf0, 0x3f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x33, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x21, 0xff, 0xc7, 0xff, 0xe3, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xc0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xe0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x01, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xe7, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0xfe, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xe0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xcf, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xc7, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x03, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xf8, 0xff, 0xff, 0xff, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfc, 0x1f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff,
    0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff
};

//  use of 2bmp1bpp.exe
//  use of Paintuino.exe

unsigned char const  MikroC_Everywhere_96x64[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x01,0xC3,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x00,0xFF,0xC0,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x01,0xFF,0xC0,
  0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x03,0xE0,0x00,
  0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
  0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
  0x00,0x07,0x06,0x00,0x03,0x80,0x00,0x60,0x38,0x07,0x00,0x00,
  0x00,0xFF,0xBF,0x81,0xC3,0x83,0x8F,0xE0,0xFE,0x07,0x00,0x00,
  0x00,0xFF,0xFF,0xC1,0xC3,0x87,0x8F,0xE1,0xFF,0x07,0x00,0x00,
  0x00,0xF9,0xF1,0xC1,0xC3,0x8F,0x0F,0x83,0xC7,0x87,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x87,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x9C,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xB8,0x0E,0x07,0x01,0xC7,0x00,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x80,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x9E,0x0E,0x07,0x83,0xC3,0x80,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x83,0xC0,0x00,
  0x00,0xE0,0xE0,0xE1,0xC3,0x8F,0x0E,0x03,0xFF,0x81,0xFF,0xC0,
  0x00,0xE0,0xE0,0xE1,0xC3,0x87,0x8E,0x01,0xFF,0x00,0xFF,0xC0,
  0x00,0xC0,0xE0,0xE1,0xC3,0x03,0x8E,0x00,0xFE,0x00,0x7F,0xC0,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x01,0xFF,0x80,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
  0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
  0x00,0x71,0x08,0xE2,0xB1,0xA0,0x27,0x83,0x8A,0x38,0x4A,0x80,
  0x00,0xF9,0x99,0xF3,0xF1,0xA2,0x37,0xC7,0xCE,0x7C,0x4A,0x80,
  0x00,0x8D,0x9B,0x33,0x31,0xA7,0x24,0x6C,0xCC,0xCC,0x4A,0x80,
  0x01,0x8D,0x9B,0x1A,0x11,0x37,0x64,0x6C,0x48,0xC6,0x42,0x00,
  0x01,0xFD,0x9B,0xFA,0x1B,0x37,0x64,0x6F,0xE8,0xFE,0x00,0x00,
  0x01,0xF8,0x93,0xF2,0x1B,0x35,0x64,0x6F,0xC8,0xFC,0x00,0x00,
  0x01,0x80,0xF3,0x02,0x1B,0x3D,0xE4,0x6C,0x08,0xC0,0x00,0x00,
  0x00,0xC0,0xF3,0x02,0x0E,0x3D,0xC4,0x6C,0x08,0xC0,0x00,0x00,
  0x00,0xFC,0xF1,0xF2,0x0E,0x1D,0xC4,0x67,0xC8,0x7C,0x00,0x00,
  0x00,0x78,0x60,0xF2,0x0E,0x18,0xC4,0x63,0xC8,0x3C,0x00,0x00,
  0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

// paintuino.exe paulfjujo.bmp
const unsigned char paulfjujo[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x80,0x30,0x00,0x00,0x00,0x00,0x00,
  0x03,0xF0,0x00,0x00,0x01,0x80,0xF8,0x00,0x00,0x00,0x00,0x00,
  0x03,0xF8,0x00,0x00,0x01,0x81,0xF0,0xC0,0x00,0x08,0x00,0x00,
  0x03,0xFC,0x00,0x00,0x01,0x81,0xC0,0xC0,0x00,0x1C,0x00,0x00,
  0x06,0x1C,0x00,0x00,0x01,0x81,0x80,0xC0,0x00,0x18,0x00,0x00,
  0x06,0x0C,0x00,0x00,0x01,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
  0x06,0x0C,0x00,0x00,0x03,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
  0x06,0x0C,0x00,0x00,0x03,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
  0x06,0x0C,0x1C,0x10,0x23,0x0F,0xE0,0x81,0x02,0x08,0x07,0x00,
  0x06,0x1C,0x7E,0x18,0x63,0x1F,0xE1,0xC1,0x86,0x18,0x1F,0x80,
  0x06,0x38,0xFF,0x38,0x63,0x1F,0xE1,0xC3,0x86,0x18,0x3F,0xC0,
  0x0F,0xF9,0xE7,0x30,0x63,0x06,0x01,0xC3,0x06,0x18,0x39,0xC0,
  0x0F,0xF1,0xC6,0x30,0x63,0x06,0x01,0xC3,0x06,0x18,0x70,0xC0,
  0x0F,0xC1,0x86,0x30,0xE3,0x06,0x01,0x83,0x0E,0x18,0x60,0xC0,
  0x0C,0x03,0x86,0x30,0xE7,0x06,0x01,0x83,0x0E,0x38,0x60,0xC0,
  0x0C,0x03,0x06,0x30,0xC6,0x06,0x01,0x83,0x0C,0x38,0x60,0xC0,
  0x0C,0x03,0x06,0x30,0xC6,0x06,0x01,0x83,0x0C,0x38,0xE0,0xC0,
  0x1C,0x03,0x06,0x70,0xC6,0x0E,0x01,0x87,0x0C,0x38,0xE1,0x80,
  0x18,0x03,0x06,0x70,0xC6,0x0C,0x01,0x87,0x0C,0x38,0xE1,0x80,
  0x18,0x03,0x0E,0x70,0xC6,0x0C,0x01,0x87,0x0C,0x30,0x63,0x80,
  0x18,0x03,0x9E,0x7F,0xC6,0x0C,0x01,0x87,0xFC,0x30,0x7F,0x00,
  0x18,0x03,0xFE,0x3F,0xCE,0x0C,0x01,0x83,0xFC,0x30,0x7E,0x00,
  0x00,0x01,0xF6,0x3F,0xCC,0x0C,0x03,0x83,0xFC,0x30,0x3C,0x00,
  0x00,0x00,0x00,0x00,0x80,0x0C,0x03,0x80,0x08,0x30,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x08,0x03,0x80,0x00,0x30,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x23,0x00,0x06,0x30,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x73,0x00,0x06,0x30,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x37,0x00,0x07,0x60,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0xE0,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x03,0xC0,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x01,0x80,0x00,0x00,
  0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,
  0x00,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,
  0x00,0x01,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x00,
  0x00,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x00,
  0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,
  0x00,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,
  0x00,0x07,0x60,0x86,0x03,0x80,0x0E,0x00,0x00,0x3D,0x04,0x30,
  0x00,0x3F,0xF1,0xFF,0x0F,0xE0,0x7F,0x80,0x01,0xFF,0xCF,0xF8,
  0x00,0x7F,0xF3,0xFF,0x1F,0xF0,0xFF,0xC0,0x01,0xFF,0xCF,0xFC,
  0x00,0x3F,0xE3,0xFF,0x3C,0xF1,0xF3,0xC0,0x01,0xFF,0x1F,0xFC,
  0x00,0x0F,0x03,0xE7,0x78,0xF1,0xC7,0xC0,0x00,0x78,0x1F,0x38,
  0x00,0x0E,0x03,0x86,0x77,0xE3,0xDF,0x80,0x00,0x78,0x1E,0x38,
  0x00,0x0E,0x03,0x80,0xFF,0xC3,0xFE,0x00,0x00,0x70,0x1C,0x00,
  0x00,0x0E,0x07,0x80,0xFF,0x03,0xF8,0x00,0x00,0x70,0x1C,0x00,
  0x00,0x0E,0x07,0x80,0xFC,0x03,0xE0,0x00,0x00,0x70,0x1C,0x00,
  0x00,0x1E,0x07,0x00,0xF0,0x23,0x80,0x80,0x00,0x70,0x3C,0x00,
  0x00,0x1E,0x07,0x00,0xFD,0xF3,0xE7,0x80,0x00,0xF0,0x3C,0x00,
  0x70,0x1C,0x07,0x00,0x7F,0xE3,0xFF,0x83,0x80,0xF0,0x38,0x00,
  0xF0,0x1C,0x07,0x00,0x3F,0xC1,0xFF,0x07,0x80,0xE0,0x38,0x00,
  0x60,0x1C,0x02,0x00,0x0E,0x00,0x38,0x03,0x80,0xE0,0x10,0x00,
  0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};

 // ------------------------------------------------------
// Picture name: asd_bmp
// GLCD Model: Nokia3310 Like
// ------------------------------------------------------
unsigned char const asd_bmp[60] = {
  2,  15,  63, 252, 252, 132,   6,   6,  66, 227,   3, 195,
 34, 230,   4, 236, 172, 236,  12, 196,  38,  38,  35,   3,
  3, 131, 230, 254,  63,  14,
  0,   0,   0,   0,   7,  31, 126, 248, 224, 227, 224, 225,
226, 225, 224, 224, 224, 224, 224, 225, 226, 226, 225, 240,
252,  63,   7,   1,   0,   0
};

const char HELP[][17]={
   " Keyboard Cdes  " ,
   " STArt save->EEP" ,
   " HALt  save  EEP" ,
   " RELit from<-EEP" ,
   " DUMp all Flash " ,
   " LED1 ou LED0   " ,
   " MOT1 ou MOT0   " ,
   "U;JJ;MM;AA;D;HH;" ,
   };

#define MAXLEN 128
unsigned  char buffer1[MAXLEN] ;

unsigned char TEXTE[128];
unsigned char *txt;
unsigned char Page_Ram[64];
unsigned char c1,c2;
unsigned char CRam1[32];
unsigned char *CRam;

int Page_Count;
unsigned int AdrE;

char CRam0[16];
volatile int Index1, CptErr,i1;
volatile int count;
unsigned int i,j,k;
unsigned int ir;
unsigned char c0;
unsigned int Index;  // pour EEPROM 24LC512
long L0;
unsigned long L1;
unsigned int PageFlash;
unsigned int M,M0,M1;

char UnCar,err;
unsigned char Seconde, Minute, Heure, week_day, day, Mois, Annee;
unsigned char octet;
unsigned char DateTime[9];
char Ligne18Cars=0;

volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Store:1;
                 unsigned Elligible:1;
                 unsigned Togle:1;            
                 unsigned Second;
                 unsigned See:1;
                 unsigned Full:1;
                 unsigned Lcd:1;
               }Drapeaux ;   
float F1;  

// -------- UART 1 ------------------------
void redirige_RS232(int wcr,unsigned char *T);
void Write_String(unsigned char *T);
void CRLF1(void);
void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char *Float2Ascii (float x, unsigned char *str,char precision);
void UART1_Write_CText(const char *txt); 
 
//---- EEPROM PIC  1024 bytes for 18F  ================
unsigned char EEPROM_Lect(int adrE) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned int adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(int * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);

// --- RTC DS1307 ------
void  Init_DS1307(void);
void Write_Time(void) ;
void Read_Time(char *Seconde, char *min, char *Heure, char *week_day, char *day, char *Minute, char *Annee);
void Transform_Time(char  *Seconde, char *min, char *Heure, char *week_day, char *day, char *Minute, char *Annee);
void Display_Time(char Seconde, char Minute, char Heure); 
void Display_Date(char week_day,char day, char Mois, char Annee)  ;
void Write_Byte(unsigned char c2);


void interrupt()
 {
   if ((RCIE_bit) && (RCIF_bit))
    {
       c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;     // clear OERR flag
       RCSTA.CREN = 1 ;
       CptErr++;
       c1 = RCREG;          // empty buffer
       c1=0;
      } 
      else
       if(RCSTA.FERR==1 )
       {
        CptErr++;
        c1=0;
       } 
       else
       {
         c1 = RCREG;        // no errors
         if ((c1==CR) || (i1>=MAXLEN)) 
         {
           Drapeaux.Full=1;
            buffer1[i1]=0;
           Index1=i1;
           i1=0;
           c1=0;
         }
         else
         { 
           buffer1[i1]=c1;
           Index1=i1;
          i1++;
         }
       }
    }
     // ------ Timer0 --------------
    if ((T0IE_bit)&&(TMR0IF_bit))
     {
         TMR0IF_bit    = 0;
         TMR0H         = 0x67;
         TMR0L         = 0x69;
         Drapeaux.Elligible=1;
         Soft_I2C_Break();
      }
   #ifdef Use_Timer1
   // -- Timer1 --------------
    if ((TMR1IE_bit)&&(TMR1IF_bit))
      {  
         TMR1IF_bit    = 0;
        // TMR1H=Hi (Valeur);
        // TMR1L=Lo (Valeur);
         TMR1H= (3035 >> 8);
         TMR1L= (3035 & 0x00FF);
         //TMR1H=  0x0B; // 3035  init  100mS at 20Mhz
         //TMR1L=  0xDB;
         count1++;                  //Increase counter by one
      if (count1 >= 10)         //Adjust this value for different time (10ms x 100 = 1000ms or 1sec)
        {
         Drapeaux.Second=1;  
         count1 = 0;
         }
      }
   #endif     
   
   #ifdef Test_Timer2
   if((TMR2IE_bit) && (TMR2IF_bit))
        {
        LedRouge=~LedRouge;
         //     TXREG='*';    to see tha interrupt has occured on terminal UART
         TMR2=0;
        TMR2IF_bit=0;
       }
   #endif    
 }

#ifdef Test_Timer2
 void Init_Timer2(void)
{        
        TMR2 = 0x00;
        //T2CON = 0x75;  // Prescaler 4, Postscaler 
        T2CON.TOUTPS0=0x0F; // 1:16 Postscale
        T2CON.T2CKPS0=3 ;  // Precaler= 16
        T2CON.TMR2ON=1; // Timer 2 ON
        
        T2CON=0b01111111; 
        TMR2IF_bit = 0;
        CCP1CON=0;
        TMR2IE_bit = 1;
        TMR2=0;
        PR2 = 0xFF;     
}
#endif

#include "MyLib_Nokia_96x64.h"
/*
const char table[480] ....
const char Font_7_8 []={   /   685   System 7x8 (char #32 to #128)
const char Font_3_6 []={   // 195  System 3x6 (char #32 to #96)
unsigned char Ram_Video[768];
extern void Nokia_Init_Lcd(void);
extern void Nokia_SendCmd(char x);
extern void Nokia_SendData(char x);
extern void Nokia_Erase_Line(int L);
extern void Nokia_Clear(void);
extern void Nokia_Write_Char_At(char Col,char Lig, unsigned char c);
extern void Nokia_Chr_8x7(char Lx,char Cx, char charsel);
extern void Nokia_SendChar(char x);
extern void Nokia_SendPack(char x);
extern void Nokia_Text_Lig_Col(int y, int x, char size,Byte *caracter);
extern void NOKIA_CText_5x7(char L,char  C, const char *TxT);
extern void NOKIA_CText_8x7(char L,char  C, const char *txt);
extern void Nokia_Raz_Ram_Video(void)  ;
extern void Nokia_Goto_xy(char xnokia, char ynokia)  ;
extern void Nokia_Pos_Lig_Col( char Lig, char Col, char size);
extern void Nokia_Put_Pixel (char x, char y, char color) ;
extern void Nokia_Bitmap(unsigned char x, unsigned char y, unsigned char * bitmap, unsigned char height,unsigned char width);
extern void Nokia_Print_Ram_Video(void);
extern void Nokia_Partial_Image(char xNOKIA, char yNOKIA, char xImage, char array_length, const char *image);
extern void Nokia_Image_96x64(const char *image) ;
extern void Nokia_Text(int x, int y, char size, char *caracter);
extern void Nokia_Line (char x1, char y1, char x2, char y2, char color);
extern void Nokia_Rect (char x1, char y1, char x2, char y2,  char color);
extern void Bargraph (int V , int ligne);
#include "MyLib_Nokia_96x64.c"
*/


#ifdef EEPROM_24LC512
 #include "My_24LC256_Eeprom.h"
/*---- EEPROM 24LC512 64K bytes
void Write_Byte_To_24LC256(unsigned int Adr, unsigned char cx);
unsigned char Read_Byte_from_24LC512(unsigned int Adr);
void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg);
void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg);
void Save_Date_2_24LC512(void);
unsigned int My_ADC_Read(unsigned char channel);
void My_ADC_Init(void);
*/

#endif


 #ifdef EEPROM_PIC_1024
//------  EEPROM 1024 du  PIC18F---------------

unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{
    EEADR =(unsigned char)(AdrL  &0x00FF);
    EEADRH =(unsigned char) ((AdrL >>8) & 0x0003);   //Bits 2-7 are masked off since EEPROM is only 1KB
        EECON1.EEPGD=0;     // 0= adressage EEPROM
        Delay_ms(1);
        EECON1.CFGS=0;      // 0= acces data EEPROM
        EECON1.RD=1;        // arme Lecture EEprom
        Delay_ms(20);;
        return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
    EEADR =AdrE & 0xFF;
    EEADRH = (AdrE>>8)& 0x03;   //Bits 2-7 are masked off since EEPROM is only 1KB
        EEDATA=car;
        EECON1.EEPGD=0;
        EECON1.WREN=1;            // autorise ecriture EEPROM
        EECON1.CFGS =0;
  if(INTCON.GIE ==1)
    {
    INTCON.GIE =0 ;
    dr=1;
    }
        EECON2=0x55;
        EECON2=0xAA;
        EECON1.WR=1;
        while (PIR2.EEIF==0);
        PIR2.EEIF=0;
        EECON1.WREN=0;
        if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int adrx, unsigned char * ptr1)
{
        while (*ptr1) 
        {
          EEPROM_Ecr(adrx++,*ptr1++);
          if (adrx>1023) break;
          }
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
  do
  {
  if ( PtrE >1023) break;
  c = EEPROM_Lect(PtrE);
  if ( c==0) break;
  UART1_Write(c);
  PtrE++;
  }
  while (c!=0)  ;
 Delay_ms(100);
}

void RAZ_PIC_EEPROM()
{
   // blanchit EEPROM
   for(k=0;k<1023;k++)
   {
    EEPROM_Ecr(k,0x20); // ecrit " " (space) a l'adresse adrE
   }
 }

void Relit_PIC_Eeprom()
{
unsigned int i,ind,dr;
char c1;
if(GIE_bit==1) dr=1;
INTCON.GIE =0 ;  // inhibe globale des IT
i=(unsigned int)EEPROM_Lect(0)<< 8 ;
ind = i +(unsigned int)EEPROM_Lect(1);
k=sprintf(txt,"Lecture Eeprom PIC  Ix=%05d\r\n",ind);
UART1_Write_Text(txt);
k=sprintf(txt,"Nb_Watt;Temp_ext;Nb_Chauffes\r\n");
UART1_Write_Text(txt);
if (ind>1023)     return;
for (i=2;i<ind;i++)
{
   c1=EEPROM_Lect(i);
   UART1_Write(c1);
}
CRLF1();
// annule la commande
if(buffer1[0]=='L')
{
 buffer1[0]=0;
 CptErr=0;
 Drapeaux.Full=0;
 PIE1.RCIE = 1;
 i1=0;
}
if(dr==1)  INTCON.GIE =1 ;  // autorisation globale des IT
}
#endif


 // *******************************************

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}
 
unsigned char *Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 adpt=str;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
return (adpt);
} 


 #ifdef Software_I2C
void Init_DS1307() 
{  // 25 avril 2016  16H59
   Seconde=0x00;
   Minute=0x59;
   Heure=0x16 ;
   day=0x25;
   Mois=0x04;
   week_day=0x01;
   Annee=0x16;
   Write_Time();
}

void Write_Time()
 {
        I2C1_Start();       // start signal
        I2C1_Wr(DS1307);    // addresse DS1307
        I2C1_Wr(0);         // start from REG 0
        I2C1_Wr(0x80);      // write $80 to REG 0. (pause counter + 0 sec)
        I2C1_Wr(Minute);      // write  Minutes to REG 1
        I2C1_Wr(Heure);        // write  Heures (mode 24H) to REG 2
        I2C1_Wr(week_day);  // write Jour semaine to REG 3
        I2C1_Wr(day);       // write  date to REG 4
        I2C1_Wr(Mois);        // write  mois to REG 5
        I2C1_Wr(Annee);      // write annee to REG 6
        I2C1_Stop();        // issue stop signal
        //I2C1_Repeated_Start(void);      // issue start signal
        I2C1_Start();       // start signal
        Delay_ms(10);
        I2C1_Wr(DS1307);      // address DS1307
        I2C1_Wr(0);         // start from word at address 0
        I2C1_Wr(0);         // write 0 to REG0 (enable counting + 0 sec)
        I2C1_Stop();        // issue stop signal
}

void Read_Time(char *Seconde, char *Minute, char *Heure, char *week_day, char *day, char *Mois, char *Annee)
 {
        I2C1_Start();
        I2C1_Wr(DS1307);
        I2C1_Wr(0);
         I2C1_Stop();
        I2C1_Start();
        Delay_ms(5);
        I2C1_Wr(0xD1);
        Delay_ms(1);
        *Seconde =I2C1_Rd(1);
        *Minute =I2C1_Rd(1);
        *Heure =I2C1_Rd(1);
        *week_day =I2C1_Rd(1);
        *day =I2C1_Rd(1);
        *Mois =I2C1_Rd(1);
        *Annee =I2C1_Rd(0);
        I2C1_Stop();
}

void Transform_Time(char  *Seconde, char *Minute, char *Heure, char *week_day, char *day, char *Mois, char *Annee)
 {
        *Seconde  =  ((*Seconde & 0x7F) >> 4)*10 + (*Seconde & 0x0F);
        *Minute  =  ((*Minute & 0xF0) >> 4)*10 + (*Minute & 0x0F);
        *Heure   =  ((*Heure & 0x30) >> 4)*10 + (*Heure & 0x0F);
        *week_day =(*week_day & 0x07);
        *day  =  ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
        *Mois   =  ((*Mois & 0x10) >> 4)*10 + (*Mois & 0x0F);
        *Annee =  ((*Annee & 0xF0)>>4)*10+(*Annee & 0x0F);
}
#endif


void Display_Time(char Seconde, char Minute, char Heure) 
{      Drapeaux.Lcd=1;  //outmode=Nokia;
        Nokia_Pos_Lig_Col(1,1,2)  ; // FIRST_ROW
       strConstRamCpy(txt,"Time: ");
       Write_String(txt);
       redirige_RS232(0,txt);
       Drapeaux.Lcd=1;
       Nokia_Write_Char_At(1,7,(Heure / 10)  + 48);
        Nokia_Write_Char_At(1,8,(Heure % 10)  + 48);
        Nokia_Write_Char_At(1,9,':');
        Nokia_Write_Char_At(1,10,(Minute / 10) + 48);
        Nokia_Write_Char_At(1,11,(Minute % 10) + 48);
        Nokia_Write_Char_At(1,12,':');
        Nokia_Write_Char_At(1,13,(Seconde / 10) + 48);
        Nokia_Write_Char_At(1,14,(Seconde % 10) + 48);
        Nokia_Write_Char_At(1,15,'.');
    // disply on terminal
       Drapeaux.Lcd=0; 
       DateTime[4]=Heure; ByteToStr( Heure,CRam0); UART1_Write_Text( CRam0);UART1_Write(':'); 
       DateTime[5]=Minute; ByteToStr(  Minute,CRam0); UART1_Write_Text( CRam0); UART1_Write(':');
       DateTime[6]=Seconde; ByteToStr( Seconde,CRam0); UART1_Write_Text( CRam0); 
       UART1_Write(';');
      
  }

 void Display_Date(char week_day,char day, char Mois, char Annee)  
 {    
       Drapeaux.Lcd=1; //outmode=Nokia;
       Nokia_Pos_Lig_Col(2,1,2)  ;
     // pour verif weekday
       ByteToStr(week_day,txt);UART1_Write_Text(txt);UART1_Write(TAB);
       strConstRamCpy(txt,JS[week_day]);

       Write_String(txt);
       redirige_RS232(0,txt);
       Drapeaux.Lcd=1;

       Nokia_Write_Char_At(2,6,(day / 10)   + 48);    // Print tens digit of day variable
       Nokia_Write_Char_At(2,7, (day % 10)   + 48);    // Print oness digit of day variable
       Nokia_Write_Char_At(2,8,'/');
       Nokia_Write_Char_At(2,9,(Mois / 10) + 48);
       Nokia_Write_Char_At(2,10,(Mois % 10) + 48);
       Nokia_Write_Char_At(2,11,'/');
       Nokia_Write_Char_At(2,12,'2');
       Nokia_Write_Char_At(2,13,'0');
       Nokia_Write_Char_At(2,14, (Annee / 10)  + 48);          // Print Annee vaiable + 8 (start from Annee 2008)
       Nokia_Write_Char_At(2,15, (Annee % 10)  + 48);
       Drapeaux.Lcd=0; 
       DateTime[0]=day;ByteToStr(day,CRam1); UART1_Write_Text( CRam1);  UART1_Write('/');
       DateTime[1]=Mois;ByteToStr( Mois,CRam1); UART1_Write_Text( CRam1); UART1_Write('/'); 
      //  DateTime[1]=Mois;ByteToStr( Bcd2Dec(Mois),CRam1); UART1_Write_Text( CRam1); UART1_Write('/'); 
       DateTime[2]=Annee;ByteToStr(Annee,CRam1); UART1_Write_Text( CRam1);    
       DateTime[3]=week_day;//IntToStr( Bcd2Dec(week_day),CRam1); UART1_Write_Text( CRam1);  // jour de la semaine sur 1 seul digit 
       UART1_Write(';');
 
}


void MAJ_RTC()
{ int m,l,j,i;
  PIE1.RCIE = 0;
  m=2; // passe par dessus "U;"
  j=0;
  
   
   CRLF1();
   l=strlen(buffer1);
   WordToStr(l,CRam0);
   UART1_Write_Text(CRam0);
   CRLF1();
   /// format de la commande
  //    JJ MM AA D HH MN       (D=jour de la semaine 0=dimanche)
  // U;24;04;16;7;12;10#
    if ((buffer1[0]=='U')&& (buffer1[l-1]=='#') && (l>=19))
     { 
         UART1_Write_CText("\n\rMise a l'heure RTC \r\n"); 
         for (i=2;i<l;i++)
          { 
            if(buffer1[i]==';')
              { 
                buffer1[i]=0;
                DateTime[j]=atoi(buffer1+m);
                m=i+1;
                j++;
              } 
          }// for i 
       // ne pas oublier le dernier! 
        buffer1[l-1]=0; // elimine # en fin de chaine
        DateTime[j]=atoi(buffer1+m);
        day=Dec2Bcd(DateTime[0]);
        Mois=Dec2Bcd(DateTime[1]);
        Annee=Dec2Bcd(DateTime[2]);
        week_day=Dec2Bcd(DateTime[3]); // jour de la semaine sur 1 seul digit
       Heure=Dec2Bcd(DateTime[4]);
       Minute=Dec2Bcd(DateTime[5]);
       Write_Time();
       buffer1[0]=0;
           
       j=0;
       CptErr=0;
       Drapeaux.Full=0;
   
     }// if buff1[0]='U'
    PIE1.RCIE = 1;
 }   



// ***********************

void redirige_RS232(int wcr, unsigned char *T)
 {
   Drapeaux.Lcd=0; //outmode=0;
  Write_String(T);
  if (wcr==1)
   {
   UART1_Write(10);
  UART1_Write(13);
   }
   Drapeaux.Lcd=1; //outmode=1;
 }

void Write_String(unsigned char *T)
{
short int i1,j1,k;
 j1=strlen(T);
   i1=0;
   do
   {
   k=T[i1];
   if (Drapeaux.Lcd==0)
      UART1_Write(k);
   else  
      Nokia_SendChar(k);
   i1++;
   }while (i1<j1);
}
 void CRLF1()
 {
 UART1_Write(13);
 UART1_Write(10);
 }

// --- Copie le texte point en ROM  vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source) {
  while (*source)
  {*dest = *source ;
    dest ++  ;
    source ++;
  }  
  *dest = 0 ;    // terminateur
}

void My_ADC_Init()       // for 18F4685
{
  ADCON0=0;     // channel 0 AN0 selected
  ADCON0.ADON=1;
  ADCON1 = 0x1B;
  ADCON1.VCFG1=0;   // -Vref =VSS
  ADCON1.VCFG0=1;   // +Vref= AN3
  //1011 D D D D D D D A A A A
  ADCON1.PCFG3= 1;
  ADCON1.PCFG2= 0;
  ADCON1.PCFG1= 1;
  ADCON1.PCFG0= 1;
  // Right justified
  ADCON2.ADFM=1;
  // 16 TAD
  ADCON2.ACQT2=1;
  ADCON2.ACQT1=1;
  ADCON2.ACQT0=0;
   // FOSC/16
  ADCON2.ADCS2=1;
  ADCON2.ADCS1=0;
  ADCON2.ADCS0=1;
}


unsigned int My_ADC_Read(unsigned char channel)
{
  int i; 
  unsigned int RawM, avg_output=0,temp=0 ;
  if(channel > 7) return 0; 
  ADCON0 =ADCON0 & 0x03;        // AND= RAZ channel selection
  ADCON0 =ADCON0 | channel<<2; // OR = Set  chanel selection
  Delay_ms(3);
  GO_bit = 1;
   _asm NOP  //  allways one instruction after setting bit GO  (MicroChip recommandation)
    while(GO_bit);  // Wait until conversion gets over
     RawM=(unsigned int) (ADRESH<<8) + ADRESL ;   // Store 10-bit output into a 16-bit variable
return(RawM);
}

 void Init_Timer0()
 {
 T0CON         = 0x85;
  TMR0H         = 0x67;
  TMR0L         = 0x69;
  GIE_bit         = 1;
  TMR0IE_bit         = 1;
  }



#ifdef Use_Timer1   
void Init_Timer1(void)    
 {
  T1CON=0;
 // T1CON=0b00110000; 
  TMR1CS_bit=0;   // FOSC /4 internal clock .. page 52
  T1CKPS1_bit=1;  //prescal select=11 => 1/8
  T1CKPS0_bit=1;
  //TMR1H= 0x0B; // Hi (3035);  // init  100mS at 20Mhz
  //TMR1L= 0xDB; // Lo (3035);
   TMR1H= (3035 >> 8);
  TMR1L= (3035 & 0x00FF); 
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=0;  //Enable interrupt TMR1
  TMR1ON_bit=0;
} 
#endif  

void Save_Index_24LC512()
{ // index suav en debut de EEPROM
  unsigned char cx;
  cx=Index >>8;
  Write_Byte_To_24LC512(0,cx);
  Delay_ms(10);
  cx=(unsigned char) (Index & 0x00FF);
  Write_Byte_To_24LC512(1,cx);
  Delay_ms(10);
}


void Aide()
{
int i;
 for (i=0;i<8;i++)
 {
    UART1_Write_CText(HELP[i]);
    CRLF1();
    Nokia_CText_5x7(i,1,HELP[i]);
 }
}
   
   
 //char tmp[20] = "";
   

void main()
{

 PORTB = 0x00;           // set PORTB to FF
 TRISB = 0xFD;           // designate portb pins as input except RB2 as output
 INIT_RTC_Direction=1;   // entree Init RTC par defaut
 RBPU_bit=0;  // pullup on PORTB
 
 PORTA = 0xFF;
 TRISA = 0xFF;          // PORTA is RA0,1,2,3,4,5=input
 TRISD=0x00; // all outputs
  
 PORTC = 0xFE;       // set PORTC to $FF
 TRISC = 0xC0;          // designate PORTC pins as output
 TRISE=0;
 PORTE=0xFF;
 LedBlanche=1;
   
 // portA A0 A1 analog
 // AN2=-Vref=0 ou 3,0V An3=+ref=4.096V   RA5,RE0,RE1,RE2 digitals,
 My_ADC_Init();
  
 Drapeaux.Lcd=0; //outmode=RS232;
 Delay_ms(200);
 LedBlanche=0;
   
 UART1_Init(57600);   // RS232     was 19200 at 10Mhz
 Delay_ms(500);
 UART1_Write(CLS);
 Delay_ms(100);
 CRLF1();
 
 UART1_Write_CText( "Mikroc Pro 6.62\r\n");
 UART1_Write_CText( "Projet : "Projet" \r\n");
 UART1_Write_CText( "Platine Nokia LCD 96x64 pixels PIC 18F4685 96K :\r\n "Source"_"Version".c\r\n");
 UART1_Write_CText( "Utilise MyLib_Nokia_96x64.H et MyLib_Nokia_96x64.c \r\n");
 txt=&TEXTE[0];
 
 // problemo avc TinyBootloader : L'eeprom est limite en taille 256 maxi
 // donc ne charge pas  au dela pour EEPROM de 1024
  UART1_Write_CText("Attention : Tinybootloader V1.98  limite EEPROM  256 bytes ! not 1024 \r\n");
  

 PrintOut_Eeprom_Msg(0x0000);
 /*
  UART1_Write_CText("Lecture 16 bytes PIC EEPROM  :  ");
  for (i=0;i<16;i++)
 {
  CRam1[i]= EEPROM_Lect(i) ;
  Delay_ms(20);
  }
 CRam1[16]=0;
 UART1_Write_Text(CRam1);
 CRLF1();
 */
 
  UART1_Write_CText("Vecteur Start Bootloader en  0x17F38=  ");
//;Address Opcode         ASM
//0x0000        0xF02EEF57          GOTO        23726
   for (i=0;i<4;i++)
  { 
    c1=FLASH_Read(0x17F38+i);
    ByteToHex(c1,txt);
    UART1_Write_Text(txt);
   }
   CRLF1();
   c1= FLASH_Read(0x17F38+2);
 //  ByteToHex(c1,txt);
//   UART1_Write_Text(txt);
  c2= FLASH_Read(0x17F38);
  k=(int) c1 << 8 ;
  k=k  + c2;
  k=k<<1;
 // WordToHex(k,CRam1);
 // UART1_Write_Text(CRam1);
 // CRLF1();
  sprintf(txt, "Adresse point d'entree Prg MikroC = %x%x h mutiplie 2 soit %04X  ou % 5u decimal \r\n" ,(int)c1,(int)c2,k,k);
  UART1_Write_Text(txt);
  LedBlanche=1;
  txt=&TEXTE[0];
  CRam=&CRam1[0];

  L0=Get_Fosc_kHz();
  UART1_Write_CText("Freq kHz= ");
  LongToStr(L0, CRam1);
  UART1_Write_Text(CRam1);
  CRLF1();

  Nokia_Init_Lcd();       // Nokia LCD 3310
  Delay_ms(300);
  Drapeaux.Lcd=1; //outmode=Nokia;
  Nokia_Clear(); // Clear LCD


 // ------- Presentation  --------
   Nokia_Pos_Lig_Col(1,1,2);
  strConstRamCpy(txt, (const code char *)"Mikroc Pro 6.62");
  Write_String(txt);        // sur LCD
  redirige_RS232(1,txt);
   Nokia_Pos_Lig_Col(2,1,2);
  strConstRamCpy(txt,(const code char *)"Platine 18F4685 ");
  Write_String(txt);
  redirige_RS232(1,txt);
   Nokia_Pos_Lig_Col(3,1,2);
  strConstRamCpy(txt,(const code char *) "With Bootloader.");
  Write_String(txt);
  redirige_RS232(1,txt);
   Nokia_Pos_Lig_Col(4,1,2);
  strConstRamCpy (txt,(const code char *)"RTC DS1307 I2C ");
  Write_String(txt);
  redirige_RS232(1,txt);
   Nokia_Pos_Lig_Col(5,1,2);
  strConstRamCpy (txt,(const code char *)  "Paulfjujo@freefr");
  //  txt= strcpy(txt,"Paulfjujo@freefr");
  Write_String(txt);
  redirige_RS232(1,txt);
  Delay_ms(3000);
  

  Drapeaux.Lcd=1;
   Nokia_Clear();

// partie test grafique et  BMP

  // partie bugge
  /*
  UART1_Write_CText("Partial Image  \r\n");
  Nokia_Clear(); // Clear LCD
  Nokia_Raz_Ram_Video();
  Nokia_Partial_Image(3,30,30,60,asd_bmp); // partial image y=3,x=38 Image's x=30 pixels size array  60 bytes.
  Delay_ms(3000);
  */
   CRLF1();
   UART1_Write_CText("Test Sinus avec Print Ram Video  \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   for (i=0;i<96;i++)  Nokia_Put_Pixel(i,32+(int)(sin((i+j)*3.14159/30)*30),1) ;
   Nokia_Print_Ram_Video();
   Delay_ms(2000);

   UART1_Write_CText("Test avec Bitmap paulfjujo \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   Nokia_Image_96x64(paulfjujo);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);
   
   UART1_Write_CText("Test avec Bitmap MikroC_Everywhere_95x64 \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   Nokia_Image_96x64(MikroC_Everywhere_96x64);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);

   UART1_Write_CText("Test avec Bitmap image_MikroE_96x64 \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   Nokia_Image_96x64(image_MikroE_96x64);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);

   UART1_Write_CText("Test quadrillage  \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   for (i=0;i<96;i=i+12)   Nokia_Line(i,0,i,63,1);
   for (i=0;i<64;i=i+8)   Nokia_Line(0,i,95,i,1);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);

   UART1_Write_CText("Test Diagonales \r\n");
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   Nokia_Line(1,1,94,63,1);
   Nokia_Line(1,63,94,1,1);
   Nokia_Line(48,1,48,63,1);
   Nokia_Line(1,32,94,32,1);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);
   
  //  A suivre   *******************************************************
  /*
   UART1_Write_CText("\"Nokia_Text(L,C,1,*Ram txt\"  en Mode 8L de 24 cars \r\n");
   Nokia_Clear(); // Clear LCD
   Nokia_Raz_Ram_Video();
   strConstRamCpy (txt,"1er line taille1");
   Nokia_Text_Lig_Col(1,1,1,txt);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);
    UART1_Write_CText("\"Nokia_Text(L,C,2,*Ram txt\"  en Mode 8L de 16 cars \r\n");
   Nokia_Raz_Ram_Video();
   strConstRamCpy (txt,"3em line taille2");
   Nokia_Text_Lig_Col(3,1,2,txt);
   Nokia_Print_Ram_Video();
   Delay_ms(2000);
   UART1_Write_CText("\"Nokia_Text(L,C,3,*Ram txt\"  en Mode 8L de 12 cars \r\n");
   Nokia_Raz_Ram_Video();
   strConstRamCpy (txt,"5em line   3");
   Nokia_Text_Lig_Col(5,1,3,txt);
   Nokia_Print_Ram_Video();
   Delay_ms(3000);
   **************************************************************** 
   */
  

   UART1_Write_CText("\"Nokia_CText_5x7(L,C,*Rom text\" Mode 8L de 16 cars \r\n");
   Nokia_Clear(); // Clear LCD
   Nokia_CText_5x7(1,1,"Mode 8L x 16 car");
   Nokia_CText_5x7(2,1,"2em ligne......2");
   Nokia_CText_5x7(3,1,"3em ligne      3");
   Nokia_CText_5x7(4,1,"4em ligne      4");
   Nokia_CText_5x7(5,1,"5em ligne      5");
   Nokia_CText_5x7(6,1,"6em ligne      6");
   Nokia_CText_5x7(7,1,"7em ligne      7");
   Nokia_CText_5x7(8,1,"8em ligne......8");
   Delay_ms(2000);

  UART1_Write_CText("\"Nokia_CText_8x7(L,C,*Rom txt\" Mode 8L de 12 cars \r\n");
  Nokia_Clear(); // Clear LCD
  Nokia_CText_8x7(1,1,"8Lines x 12C") ;
  Nokia_CText_8x7(2,1,"2em ligne 2 ");
  Nokia_CText_8x7(3,1,"3em LIGNE 3 ");
  Nokia_CText_8x7(4,1,"4em ligne 4 ");
  Nokia_CText_8x7(5,1,"5em ligne 5 ");
  Nokia_CText_8x7(6,1,"6em ligne 6 ");
  Nokia_CText_8x7(7,1,"7em ligne 7 ");
  Nokia_CText_8x7(8,1,"8em ligne 8 ");
   Delay_ms(2000);
   
   Ligne18Cars=1;

   UART1_Write_CText("test \"Nokia_Write_Char_AT(L,C,char)\" mode 8L de 18 cars \r\n");
   UART1_Write_CText("avec Flag Ligne18cars=1\r\n");
   Nokia_Clear(); // Clear LCD
   for(j=0;j<8;j++)
   {
    Nokia_Pos_Lig_Col(j+1,1,2);
    for (i=0;i<19;i++)
     {
      Nokia_Write_Char_At(j+1,i,(i % 10)   + 48);
     }
     Delay_ms(50);
    }
    Delay_ms(3000);
     Ligne18Cars=0;

  UART1_Write_CText("3 rectangles \r\n");
  Nokia_Clear();
  Nokia_Raz_Ram_Video();
  Nokia_Rect (1,1,95,63,1);
  Nokia_Rect (8,8,80,56,1);
  Nokia_Rect (16,16,72,48,1);
  Nokia_Print_Ram_Video();
  Delay_ms(2000);
   
   Nokia_Clear();
   Nokia_Raz_Ram_Video();
   CRLF1();
   Aide();
   CRLF1();
   Delay_ms(3000);
   Nokia_Clear();
   Nokia_Raz_Ram_Video();


  #ifdef Test_Timer2
  UART1_Write_CText("\n\r Init Timer2\r\n ");
  Init_Timer2() ;
  #endif

  #ifdef Use_Timer1
  Init_Timer1();
  #endif

  UART1_Write_CText("\n\r ATTENTION : SOFTWARE I2C Init :  ");
  UART1_Write_CText(" SCL =RB6   SDA=RB7\n\r ");
  #ifdef Software_I2C
  Soft_I2C_Init ();  // car RC3 et RC4 deja utilis en SPI pour Nokia
  #else
  I2C1_Init(400000);
  #endif
  Delay_ms(1000);

  if (INIT_RTC ==0)
   {
    UART1_Write_CText("\n\rRB1=0,donc Init DS1307 par defaut au 25 avril 2016  16H59 \r\n ");
     Init_DS1307();
    }
    else
   {
     UART1_Write_CText("\n\rRB1=1, donc Lecture Date Time du RTC DS1307 \r\n ");
   }
  Drapeaux.Lcd=0;
  UART1_Write_CText(" Read RTC TIME\r\n ");
  
  Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);      // read time from RTC(DS1307)
  Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee); // format date and time
  Drapeaux.Lcd=1;
  Display_Time(Seconde, Minute, Heure);
  Display_Date(week_day, day, Mois, Annee);
  Delay_ms(2000);

   UART1_Write_CText( "\r\nInit Interrupts UART \r\n ");
//INTCON =>  GIE PEIE T0IE INTE RBIE T0IF INTF RBIF
  INTCON=0;
  RCIE_bit=1;
  UnCar=RCREG; // like RCIF_bit=0;
  PEIE_bit=1;
  GIE_bit=1;
  
  j=0;
  Drapeaux.Store=0;
  
  // recupere  indice 24LC512
  i=0;
  octet=Read_Byte_from_24LC512(i);
  k=octet<<8;
  i++;
  octet=Read_Byte_from_24LC512(i);
  Index=k+(int) octet;
  UART1_Write_CText( " Index 24LC512= ");
  txt=TEXTE;
  WordToStr(Index, txt);
  UART1_Write_Text(txt);
  CRLF1();
  
  i1=0;
  Index1=0;
  buffer1[0]=0;
  txt=TEXTE;

  Drapeaux.See=0;
  Drapeaux.Lcd=1; //outmode=Nokia;
   Nokia_Clear();
  
  Nokia_Erase_Line(4);
   Nokia_Pos_Lig_Col(4,1,2);
  strConstRamCpy( txt,(const code char *)"ADC0= ");
  Write_String(txt);
  Nokia_Erase_Line(6);
   Nokia_Pos_Lig_Col(6,1,2);
  strConstRamCpy( txt,(const code char *) "ADC1= ");
  Write_String(txt);
  Delay_ms(3000);
  

  while(1)
  {
   Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
   Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
   Drapeaux.Lcd=1;

   // affiche time sur ligne 1 du Nokia et sur UART1
   Nokia_Pos_Lig_Col(1,1,2);
   Display_Time(Seconde,Minute, Heure); 
   Nokia_Pos_Lig_Col(2,1,2);
   Display_Date( week_day, day,  Mois, Annee) ;

   Drapeaux.Lcd=0;
   UART1_Write_CText( " ADC0= ");
   txt=TEXTE;
   M0 = My_ADC_Read(0) ;
   WordToStr(M0, txt);
   Drapeaux.Lcd=1; 
    Nokia_Pos_Lig_Col(4,6,2);    // X = 0  15   Y=1  8
   Write_String(txt);
   redirige_RS232(0,txt); 
   Drapeaux.Lcd=0;  
   UART1_Write (';');
   Drapeaux.Lcd=1;  
   Bargraph (M0 ,5) ;

   LedBlanche=! LedBlanche;
   
   txt=TEXTE;
   UART1_Write_CText( " ADC1= ");
   txt=TEXTE;
   M1 = My_ADC_Read(1) ;
   WordToStr(M1, txt);
   Drapeaux.Lcd=1; 
    Nokia_Pos_Lig_Col(6,6,2);
   Write_String(txt);
   redirige_RS232(0,txt);
   Bargraph (M1 ,7) ;

   j++;
   if (j>1023)j=0;
   if(Drapeaux.Store==1) j=Index/64;
   Bargraph (j ,8) ;
   Drapeaux.Lcd=0;
   // indice=J;
   WordToStr(j, txt);
   Drapeaux.Lcd=1;
   Nokia_Pos_Lig_Col(8,6,2);
   Write_String(txt);
   
   
   if (Drapeaux.Store==0) CRLF1();
   
    #ifdef EEPROM_24LC512
   if (Drapeaux.Store==1)
   {
      UART1_Write(TAB);
      Drapeaux.Lcd=1;
      CRam=CRam1;
       Nokia_Pos_Lig_Col(2,0,2);
      strConstRamCpy( CRam,(const code char *)"Next Idx=  ");
      WordToStr(Index,CRam+11);
      Write_String(CRam);
      redirige_RS232(1,CRam);
      octet=M1 >> 8;
     Write_Byte_To_24LC512(Index,octet);
     Delay_ms(10);
     Index++;
     octet= (M1 & 0x00FF);
     Write_Byte_To_24LC512(Index,octet);
     Delay_ms(10);
     Index++;
     Save_Index_24LC512();
    }
   #endif
  //------------------------------------------------
 
   if( Drapeaux.Full==1)
   { 
      UART1_Write_Text( buffer1);
      CRLF1();
      // ========= Help =============
       if ((buffer1[0]=='A') && (buffer1[1]=='I')&& (buffer1[2]=='D')&& (Index1==3))
      {
      Aide();
       buffer1[0]=0;
       Delay_ms(2000);
       CRLF1();
      }
     // ===== MAJ RTC ===============
     // format de la commande :  JJ MM AA D HH MN       (D=jour de la semaine 7=dimanche ??
     // U;24;04;16;7;12;10#
     if ((buffer1[0]=='U') &&  (buffer1[19]=='#'))
      {
          MAJ_RTC();
         Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);      // read time from RTC(DS1307)
         Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee); // format date and time
         Display_Time(Seconde, Minute, Heure);
         Display_Date(week_day, day, Mois, Annee);
          buffer1[0]=0;
      }
      //---   Cde Moteur -------------
      // MOT1   MOT0
      #ifdef Keyboard_Cdes
      if ((buffer1[0]=='M') && (buffer1[1]=='O')&& (buffer1[2]=='T')&& (Index1==4))
      {
       Drapeaux.Lcd=1; 
        Nokia_Pos_Lig_Col(8,0);
       strConstRamCpy(txt,"Cde Moteur")  ;
       if (buffer1[3]=='1') strConstRamCpy(txt+10," ON ");  //   txt= strcpy(txt,"Cde Moteur ON ");
       if (buffer1[3]=='0') strConstRamCpy(txt+10," OFF");
       Write_String(txt);
       redirige_RS232(1,txt);
        buffer1[0]=0;
      }
      // ----- Cde LED --------------
     if ((buffer1[0]=='L') && (buffer1[1]=='E') && (buffer1[2]=='D')&& (Index1==4))
      { // LED1<CR>   LED0<CR>
       Drapeaux.Lcd=1; 
        Nokia_Pos_Lig_Col(8,0);
       strConstRamCpy(txt,"Led Rouge");
       if (buffer1[3]=='1')
       {
          strConstRamCpy(txt+9,"  ON   ");
          LedRouge=0;     // logic inverse !
       }   
       if (buffer1[3]=='0')
       {
          strConstRamCpy(txt+9,"  OFF  ");
           LedRouge=1;
       }   
       Write_String(txt);
       redirige_RS232(1,txt);
      }
      #endif

    // -------------------------------------------
    #ifdef EEPROM_24LC512
    

    // -----  RAZ Index et stockage Index  EEPROM 24LC512 -------------------------
      if ((buffer1[0]=='R') && (buffer1[1]=='A') && (buffer1[2]=='Z')&& (Index1==3))
      {
         UART1_Write_CText("\r\nRAZ Idx saveEeprom\r\n");
         Index=0;
         Save_Index_24LC512();
      }
      //----- START ECRITURE DANS EEPROM 24LC512 ----------------
    if ((buffer1[0]=='S') && (buffer1[1]=='T') && (buffer1[2]=='A') && (Index1==3))
    {// STA<CR>
     UART1_Write_CText("\r\nSTART saveEeprom\r\n");
     Drapeaux.Lcd=1;
     CRam=CRam1;
      Nokia_Pos_Lig_Col(3,0,2);
     strConstRamCpy(CRam,"START saveEeprom");
     Write_String(CRam);
     Drapeaux.Store=1;
     Index++;
     Save_Date_Time_To_24LC512();
     Index++;
    }
     
    if ((buffer1[0]=='H') && (buffer1[1]=='A') && (buffer1[Z]=='L')&& (Index1==3))
    { //HAL<CR>
      Drapeaux.Lcd=1;
       CRam=CRam1;
       Nokia_Pos_Lig_Col(3,0,2);
      strConstRamCpy(CRam,"HALT sav/Eeeprom");
      Write_String(CRam);
      redirige_RS232(1,CRam);
       Drapeaux.Store=0;
       Save_Date_Time_To_24LC512();
       Index=Index+6;
       Save_Index_24LC512();
      }
    if ((buffer1[0]=='R') && (buffer1[1]=='E') && (buffer1[2]=='L')&& (Index1==3))
    { // REL<CR>    Read EEprom   et stoppe
      Drapeaux.Store=0;
      Drapeaux.Lcd=1;
      CRam=CRam1;
       Nokia_Pos_Lig_Col(3,0,2);
      strConstRamCpy( CRam,(const code char *)"Relect. EEprom. ");
      Write_String(CRam);
      Drapeaux.Lcd=0;  
       // indice 24LC512
       octet=Read_Byte_from_24LC512(0);
       k=octet<<8;
       octet=Read_Byte_from_24LC512(1);
       Index=k+octet;
       Index++;
      CRam=CRam1;
      WordToStr(Index,CRam);
      UART1_Write_Text(CRam);
      CRLF1();
      CRam=CRam1;
      for (i=2;i<8;i++)
      {
        octet=Read_Byte_from_24LC512(i);
         //UART1_Write(octet);
          ByteToHex(octet,CRam);
           UART1_Write_Text(CRam);
      }
      CRLF1();
      CRam=CRam1;
      for(i=8;i<=Index;i++)
      {
        k=(i-6)>>1;
        WordToStr(k+1,CRam);
        UART1_Write_Text(CRam);    UART1_Write(TAB);
        octet=Read_Byte_from_24LC512(i);
        i++;
        M1= (Read_Byte_from_24LC512(i)<<8 ) + octet;
        WordToStr(M1,CRam);
        UART1_Write_Text(CRam);    UART1_Write(TAB);
        F1=(float)M1*0.0048828125;
        Float2Ascii (F1, CRam1,3);  // my function .. keep same width
        UART1_Write_Text(CRam1);
        CRLF1();
      }
    }
     #endif    // EEPROM_24LC512
     
     #ifdef Dump
     
    if ((buffer1[0]=='D') && (buffer1[1]=='U')&& (buffer1[2]=='M')&& (Index1==5))
     { // DUM01<CR>  Dump page 01     DUM95  DUM dernier page 18F4685
       GIE_bit=0;
      PageFlash=atoi(buffer1+3);
      UART1_Write_CText("\r\nDUMP FLASH PIC page : ");
      UART1_Write_Text(buffer1+3);
      txt=TEXTE;
      if ((PageFlash<96) && (PageFlash>=0))
      {
        L1=(unsigned long)PageFlash << 10; // page de 1K
        L1=(unsigned long)PageFlash *1024; // page de 1K
        UART1_Write_CText("  soit  partir de : ");
        LongWordToHex(L1,txt);
        UART1_Write_Text(txt); CRLF1();
        for (ir=0;ir<1024;ir++)    // 1Ko
         {
          if ((ir%16)==0)
           {
            CRLF1();
            WordToHex(ir,txt);
            UART1_Write_Text(txt);UART1_Write(' ');
          }
          L1=((long)PageFlash << 10) + (long)ir;   // necessite des parentheses apres le SHL
          // L1=(long)PageFlash *1024 + (long)ir;
          c0 = FLASH_Read(L1) ;
          Delay_ms(25);
          ByteToHex(c0, txt);
          UART1_Write_Text(txt);UART1_Write(' ');
         } // for ir
         UART1_Write_CText("\r\n  Flash read 64 bytes\r\n");
         Nokia_Raz_Ram_Video();   // RAZ Ram Video de 768 bytes
         L1=0x017C00+0x0003C0;
         UART1_Write_CText("  soit  partir de : ");
         LongWordToHex(L1,txt);
         UART1_Write_Text(txt); CRLF1();
         FLASH_Read_N_Bytes(L1,Ram_Video,64);
         for (ir=0;ir<64;ir++)
         {
           if ((ir%16)==0)
           {
           CRLF1();
           Delay_ms(100);
           WordToStr(ir,txt);
           UART1_Write_Text(txt);UART1_Write(' ');
           }
           ByteToHex(Ram_Video[ir], txt);
           UART1_Write_Text(txt);UART1_Write(' ');
         }
          Nokia_Raz_Ram_Video();   // RAZ Ram Video de 768 bytes
         CRLF1();
       }
       else
         UART1_Write_CText("\r\nERROR Cde DUMP, format :  DUM00<CR>  .. DM95<CR>\r\n ");
       CRLF1();
       GIE_bit=1;
      
     }
     
     #endif
     
     buffer1[0]=0;
    Drapeaux.Full=0;
    Index1=0;
    i1=0;
    Delay_ms(1000);
   }


   
 } //while
}


    

/*


23/04/2016
18F4685 Platine nokia et bootloader


Mikroc Pro 6.62
 Projet : 18F4685_Platine_Nokia_160423_40Mhz.mcppi.
Platine Nokia  PIC 18F4685  23-04-2016
Nokia LCD 96x64 pixels
Attention : Tinybootloader V1.98  limite EEPROM  256 bytes ! not 1024
  Lecture 16 bytes PIC EEPROM  :  BOOTLOADER 2016
Vecteur Start Bootloader en  0x17F38=  C0EF34F0
Adresse point d'entree Prg MikroC = 34c0 h mutiplie 2 soit 6980  ou  27008 decimal
Freq kHz=       40000
Mikroc Pro 6.62
Platine 18F4685
With Bootloader.
RTC DS1307 I2C
Paulfjujo@freefr
Test Sinus avec Print Ram Video
Test avec Bitmap paulfjujo
Test avec Bitmap MikroC_Everywhere_95x64
Test avec Bitmap image_MikroE_96x64
Test quadrillage
Test Diagonales
"Nokia_CText_5x7(L,C,*Rom text" en Mode 8L de 16 car
8 lignes de 12 car
Flag Ligne18cars=1 pout test avec 18 cars par ligne
test Nokia_Write_Char_AT .. 8x18 cars
3 rectangles

 ATTENTION : SOFTWARE I2C Init :   SCL =RB6   SDA=RB7

 re-Lecture DS1307
  Read RTC TIME
 Time:  19: 25: 22;Samed 23/  4/ 16;
Keyb Cdes :
- STArt sauve -> 24LC512
- HALt  sauve x 24LC512
- RELit <-  from 24LC512
- DUMp all Flash area

Init Interrupts UART
  Index 24LC512=  2759
Time:  19: 25: 28;Samed 23/  4/ 16; ADC0=   403; ADC1=   577
Time:  19: 25: 29;Samed 23/  4/ 16; ADC0=   403; ADC1=   578
Time:  19: 25: 29;Samed 23/  4/ 16; ADC0=   403; ADC1=   577
Time:  19: 25: 30;Samed 23/  4/ 16; ADC0=   403; ADC1=   577

=============================================================


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F4685 -LHF -C -O00000014 -fo40 -N"
:C\_MikroC\_MesProjets_MikroC\_18F4685_Platine_Nokia_40Mhz_2016\18F4685_Platine_Nokia_160426_40Mhz.mcppi" -EH"
:C\_MikroC\_MesProjets_MikroC\_18F4685_Platine_Nokia_40Mhz_2016\18F4685_Platine_Nokia_160426_40Mhz.ihex" -SP"
:C\_MikroC\mikroC PRO for PIC\Defs\" -SP"
:C\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"
:C\_MikroC\_MesProjets_MikroC\_18F4685_Platine_Nokia_40Mhz_2016\" -SP"
:C\_MikroC\_MesProjets_MikroC\_18F4685_Platine_Nokia\" -IP"
:C\_MikroC\_MesProjets_MikroC\_18F4685_Platine_Nokia_40Mhz_2016\" "18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c" "
__Lib_Math.mcl" "
__Lib_MathDouble.mcl" "
__Lib_System.mcl" "
__Lib_Delays.mcl" "
__Lib_CType.mcl" "
__Lib_CString.mcl" "
__Lib_CStdlib.mcl" "
__Lib_CMath.mcl" "
__Lib_Conversions.mcl" "
__Lib_Sprintf.mcl" "
__Lib_SoftI2C.mcl" "
__Lib_FLASH_w64_e64.mcl" "
__Lib_UART_c67.mcl"
0 1139 Available RAM: 3307 [bytes], Available ROM: 98304 [bytes]
0 122 Compilation Started 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
177 1163 Variable 'j' has been declared, but not used mylib_nokia_96x64.c
402 1163 Variable 'i' has been declared, but not used mylib_nokia_96x64.c
1027 1163 Variable 'i' has been declared, but not used 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1122 1509 Generated baud rate is 57471 bps (error = 0.22 percent) 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1735 123 Compiled Successfully 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
136 1164 Variable 'i' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
213 1164 Variable 'c' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
232 1164 Variable 'cx' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
328 1164 Variable 'data1' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
329 1164 Variable 'charposition' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
687 1164 Variable 'c1' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1028 1164 Variable 'RawM' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1028 1164 Variable 'avg_output' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1028 1164 Variable 'temp' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
1071 1164 Variable 'cx' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c
0 127 All files Compiled in 219 ms
0 1144 Used RAM (bytes): 1237 (37%)  Free RAM (bytes): 2070 (63%) Used RAM (bytes): 1237 (37%)  Free RAM (bytes): 2070 (63%)
0 1144 Used ROM (bytes): 40122 (41%)  Free ROM (bytes): 58182 (59%) Used ROM (bytes): 40122 (41%)  Free ROM (bytes): 58182 (59%)
0 125 Project Linked Successfully 18F4685_Platine_Nokia_160426_40Mhz.mcppi
0 128 Linked in 109 ms
0 129 Project '18F4685_Platine_Nokia_160426_40Mhz.mcppi' completed: 359 ms
0 103 Finished successfully: 26 avr. 2016, 11:49:21 18F4685_Platine_Nokia_160426_40Mhz.mcppi
232 1164 Variable 'cx' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
328 1164 Variable 'data1' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
329 1164 Variable 'charposition' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
695 1164 Variable 'c1' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
1033 1164 Variable 'RawM' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
1033 1164 Variable 'avg_output' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
1033 1164 Variable 'temp' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
1076 1164 Variable 'cx' has been eliminated by optimizer 18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160423.c
0 127 All files Compiled in 219 ms
0 1144 Used RAM (bytes): 1234 (37%)  Free RAM (bytes): 2073 (63%) Used RAM (bytes): 1234 (37%)  Free RAM (bytes): 2073
(63%)
0 1144 Used ROM (bytes): 38363 (39%)  Free ROM (bytes): 59941 (61%) Used ROM (bytes): 38363 (39%)  Free ROM (bytes):
59941 (61%)
0 125 Project Linked Successfully 18F4685_Platine_Nokia_160423_40Mhz.mcppi
0 128 Linked in 109 ms
0 129 Project '18F4685_Platine_Nokia_160423_40Mhz.mcppi' completed: 515 ms
0 103 Finished successfully: 23 avr. 2016, 19:27:19 18F4685_Platine_Nokia_160423_40Mhz.mcppi



*/