#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
#line 139 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
sbit Soft_I2C_Scl at RB6_bit;
sbit Soft_I2C_Sda at RB7_bit;
sbit Soft_I2C_Scl_Direction at TRISB6_bit;
sbit Soft_I2C_Sda_Direction at TRISB7_bit;
sbit INIT_RTC at RB1_bit;
sbit INIT_RTC_Direction at TRISB1_bit;
#line 165 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
const code char mesg0[]="MikroC 18F4685 avec Bootloader Platine paulfjujo  \r\n";
const code char mesg1[]="RTC+UART+I2C+PCF8574+24LC256+Nokia3310 Q=10Mhz x PLL=40MHz\n\r";
const code char * Messages[]={mesg0,mesg1};

const code char JS[7][6] ={"Diman","Lundi","Mardi","Mercr","Jeudi","Vendr","Samed"};


 unsigned char const image_MikroE_96x64[768] = {
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0xff, 0x00, 0x01, 0xff, 0xc0, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe0, 0x0f, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xf0, 0x3f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0x00, 0x30, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x33, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x21, 0xff, 0xc7, 0xff, 0xe3, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc1, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xc0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xe0, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x01, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xe7, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xef, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0xfe, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xff, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xe0, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x3f, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xcf, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x0f, 0xff, 0xc0, 0xff, 0xfc, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x0f, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xc7, 0xff, 0xe1, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe7, 0xff, 0xf7, 0xff, 0xf8, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xe3, 0xff, 0xff, 0xff, 0xf0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x03, 0xff, 0xff, 0xff, 0xe0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x22, 0x00, 0x01, 0xff, 0xff, 0xff, 0xc0, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xf8, 0xff, 0xff, 0xff, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xfc, 0x1f, 0xff, 0xfe, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x23, 0xff, 0xfe, 0x07, 0xff, 0xf8, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x13, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff,
 0xff, 0xfe, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x23, 0xff, 0xff
};




unsigned char const MikroC_Everywhere_96x64[] =
{
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x01,0xC3,0x00,0x00,0x00,0x00,0x00,0x3F,0x80,
 0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x00,0xFF,0xC0,
 0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x01,0xFF,0xC0,
 0x00,0x00,0x00,0x01,0xC3,0x80,0x00,0x00,0x00,0x03,0xE0,0x00,
 0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
 0x00,0x00,0x00,0x00,0x03,0x80,0x00,0x00,0x00,0x03,0x80,0x00,
 0x00,0x07,0x06,0x00,0x03,0x80,0x00,0x60,0x38,0x07,0x00,0x00,
 0x00,0xFF,0xBF,0x81,0xC3,0x83,0x8F,0xE0,0xFE,0x07,0x00,0x00,
 0x00,0xFF,0xFF,0xC1,0xC3,0x87,0x8F,0xE1,0xFF,0x07,0x00,0x00,
 0x00,0xF9,0xF1,0xC1,0xC3,0x8F,0x0F,0x83,0xC7,0x87,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x87,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0x9C,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xE0,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xF0,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xF8,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xB8,0x0E,0x07,0x01,0xC7,0x00,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0xBC,0x0E,0x07,0x01,0xC7,0x80,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0x9E,0x0E,0x07,0x83,0xC3,0x80,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0x8E,0x0E,0x03,0x83,0x83,0xC0,0x00,
 0x00,0xE0,0xE0,0xE1,0xC3,0x8F,0x0E,0x03,0xFF,0x81,0xFF,0xC0,
 0x00,0xE0,0xE0,0xE1,0xC3,0x87,0x8E,0x01,0xFF,0x00,0xFF,0xC0,
 0x00,0xC0,0xE0,0xE1,0xC3,0x03,0x8E,0x00,0xFE,0x00,0x7F,0xC0,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x01,0xFF,0x80,
 0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
 0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x4A,0x80,
 0x00,0x71,0x08,0xE2,0xB1,0xA0,0x27,0x83,0x8A,0x38,0x4A,0x80,
 0x00,0xF9,0x99,0xF3,0xF1,0xA2,0x37,0xC7,0xCE,0x7C,0x4A,0x80,
 0x00,0x8D,0x9B,0x33,0x31,0xA7,0x24,0x6C,0xCC,0xCC,0x4A,0x80,
 0x01,0x8D,0x9B,0x1A,0x11,0x37,0x64,0x6C,0x48,0xC6,0x42,0x00,
 0x01,0xFD,0x9B,0xFA,0x1B,0x37,0x64,0x6F,0xE8,0xFE,0x00,0x00,
 0x01,0xF8,0x93,0xF2,0x1B,0x35,0x64,0x6F,0xC8,0xFC,0x00,0x00,
 0x01,0x80,0xF3,0x02,0x1B,0x3D,0xE4,0x6C,0x08,0xC0,0x00,0x00,
 0x00,0xC0,0xF3,0x02,0x0E,0x3D,0xC4,0x6C,0x08,0xC0,0x00,0x00,
 0x00,0xFC,0xF1,0xF2,0x0E,0x1D,0xC4,0x67,0xC8,0x7C,0x00,0x00,
 0x00,0x78,0x60,0xF2,0x0E,0x18,0xC4,0x63,0xC8,0x3C,0x00,0x00,
 0x00,0x00,0x00,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x1C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};


const unsigned char paulfjujo[] =
{
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x80,0x30,0x00,0x00,0x00,0x00,0x00,
 0x03,0xF0,0x00,0x00,0x01,0x80,0xF8,0x00,0x00,0x00,0x00,0x00,
 0x03,0xF8,0x00,0x00,0x01,0x81,0xF0,0xC0,0x00,0x08,0x00,0x00,
 0x03,0xFC,0x00,0x00,0x01,0x81,0xC0,0xC0,0x00,0x1C,0x00,0x00,
 0x06,0x1C,0x00,0x00,0x01,0x81,0x80,0xC0,0x00,0x18,0x00,0x00,
 0x06,0x0C,0x00,0x00,0x01,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
 0x06,0x0C,0x00,0x00,0x03,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
 0x06,0x0C,0x00,0x00,0x03,0x83,0x00,0x00,0x00,0x00,0x00,0x00,
 0x06,0x0C,0x1C,0x10,0x23,0x0F,0xE0,0x81,0x02,0x08,0x07,0x00,
 0x06,0x1C,0x7E,0x18,0x63,0x1F,0xE1,0xC1,0x86,0x18,0x1F,0x80,
 0x06,0x38,0xFF,0x38,0x63,0x1F,0xE1,0xC3,0x86,0x18,0x3F,0xC0,
 0x0F,0xF9,0xE7,0x30,0x63,0x06,0x01,0xC3,0x06,0x18,0x39,0xC0,
 0x0F,0xF1,0xC6,0x30,0x63,0x06,0x01,0xC3,0x06,0x18,0x70,0xC0,
 0x0F,0xC1,0x86,0x30,0xE3,0x06,0x01,0x83,0x0E,0x18,0x60,0xC0,
 0x0C,0x03,0x86,0x30,0xE7,0x06,0x01,0x83,0x0E,0x38,0x60,0xC0,
 0x0C,0x03,0x06,0x30,0xC6,0x06,0x01,0x83,0x0C,0x38,0x60,0xC0,
 0x0C,0x03,0x06,0x30,0xC6,0x06,0x01,0x83,0x0C,0x38,0xE0,0xC0,
 0x1C,0x03,0x06,0x70,0xC6,0x0E,0x01,0x87,0x0C,0x38,0xE1,0x80,
 0x18,0x03,0x06,0x70,0xC6,0x0C,0x01,0x87,0x0C,0x38,0xE1,0x80,
 0x18,0x03,0x0E,0x70,0xC6,0x0C,0x01,0x87,0x0C,0x30,0x63,0x80,
 0x18,0x03,0x9E,0x7F,0xC6,0x0C,0x01,0x87,0xFC,0x30,0x7F,0x00,
 0x18,0x03,0xFE,0x3F,0xCE,0x0C,0x01,0x83,0xFC,0x30,0x7E,0x00,
 0x00,0x01,0xF6,0x3F,0xCC,0x0C,0x03,0x83,0xFC,0x30,0x3C,0x00,
 0x00,0x00,0x00,0x00,0x80,0x0C,0x03,0x80,0x08,0x30,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x08,0x03,0x80,0x00,0x30,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x23,0x00,0x06,0x30,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x73,0x00,0x06,0x30,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x37,0x00,0x07,0x60,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x03,0xE0,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x03,0xC0,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x01,0x80,0x00,0x00,
 0x00,0x00,0x78,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xE0,0x00,
 0x00,0x00,0xFC,0x00,0x00,0x00,0x00,0x00,0x00,0x07,0xE0,0x00,
 0x00,0x01,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x0F,0xC0,0x00,
 0x00,0x03,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x1E,0x00,0x00,
 0x00,0x03,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,
 0x00,0x07,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x1C,0x00,0x00,
 0x00,0x07,0x60,0x86,0x03,0x80,0x0E,0x00,0x00,0x3D,0x04,0x30,
 0x00,0x3F,0xF1,0xFF,0x0F,0xE0,0x7F,0x80,0x01,0xFF,0xCF,0xF8,
 0x00,0x7F,0xF3,0xFF,0x1F,0xF0,0xFF,0xC0,0x01,0xFF,0xCF,0xFC,
 0x00,0x3F,0xE3,0xFF,0x3C,0xF1,0xF3,0xC0,0x01,0xFF,0x1F,0xFC,
 0x00,0x0F,0x03,0xE7,0x78,0xF1,0xC7,0xC0,0x00,0x78,0x1F,0x38,
 0x00,0x0E,0x03,0x86,0x77,0xE3,0xDF,0x80,0x00,0x78,0x1E,0x38,
 0x00,0x0E,0x03,0x80,0xFF,0xC3,0xFE,0x00,0x00,0x70,0x1C,0x00,
 0x00,0x0E,0x07,0x80,0xFF,0x03,0xF8,0x00,0x00,0x70,0x1C,0x00,
 0x00,0x0E,0x07,0x80,0xFC,0x03,0xE0,0x00,0x00,0x70,0x1C,0x00,
 0x00,0x1E,0x07,0x00,0xF0,0x23,0x80,0x80,0x00,0x70,0x3C,0x00,
 0x00,0x1E,0x07,0x00,0xFD,0xF3,0xE7,0x80,0x00,0xF0,0x3C,0x00,
 0x70,0x1C,0x07,0x00,0x7F,0xE3,0xFF,0x83,0x80,0xF0,0x38,0x00,
 0xF0,0x1C,0x07,0x00,0x3F,0xC1,0xFF,0x07,0x80,0xE0,0x38,0x00,
 0x60,0x1C,0x02,0x00,0x0E,0x00,0x38,0x03,0x80,0xE0,0x10,0x00,
 0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x40,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};





unsigned char const asd_bmp[60] = {
 2, 15, 63, 252, 252, 132, 6, 6, 66, 227, 3, 195,
 34, 230, 4, 236, 172, 236, 12, 196, 38, 38, 35, 3,
 3, 131, 230, 254, 63, 14,
 0, 0, 0, 0, 7, 31, 126, 248, 224, 227, 224, 225,
226, 225, 224, 224, 224, 224, 224, 225, 226, 226, 225, 240,
252, 63, 7, 1, 0, 0
};

const char HELP[][17]={
 " Keyboard Cdes  " ,
 " STArt save->EEP" ,
 " HALt  save  EEP" ,
 " RELit from<-EEP" ,
 " DUMp all Flash " ,
 " LED1 ou LED0   " ,
 " MOT1 ou MOT0   " ,
 "U;JJ;MM;AA;D;HH;" ,
 };


unsigned char buffer1[ 128 ] ;

unsigned char TEXTE[128];
unsigned char *txt;
unsigned char Page_Ram[64];
unsigned char c1,c2;
unsigned char CRam1[32];
unsigned char *CRam;

int Page_Count;
unsigned int AdrE;

char CRam0[16];
volatile int Index1, CptErr,i1;
volatile int count;
unsigned int i,j,k;
unsigned int ir;
unsigned char c0;
unsigned int Index;
long L0;
unsigned long L1;
unsigned int PageFlash;
unsigned int M,M0,M1;

char UnCar,err;
unsigned char Seconde, Minute, Heure, week_day, day, Mois, Annee;
unsigned char octet;
unsigned char DateTime[9];
char Ligne18Cars=0;

volatile struct chbits {
 unsigned FrameErr:1;
 unsigned Store:1;
 unsigned Elligible:1;
 unsigned Togle:1;
 unsigned Second;
 unsigned See:1;
 unsigned Full:1;
 unsigned Lcd:1;
 }Drapeaux ;
float F1;


void redirige_RS232(int wcr,unsigned char *T);
void Write_String(unsigned char *T);
void CRLF1(void);
void strConstRamCpy(unsigned char *dest, const code char *source);
unsigned char *Float2Ascii (float x, unsigned char *str,char precision);
void UART1_Write_CText(const char *txt);


unsigned char EEPROM_Lect(int adrE) ;
void EEPROM_Ecr(unsigned int adrE,unsigned char car);
void Save_Msg_To_EEPROM(int * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);


void Init_DS1307(void);
void Write_Time(void) ;
void Read_Time(char *Seconde, char *min, char *Heure, char *week_day, char *day, char *Minute, char *Annee);
void Transform_Time(char *Seconde, char *min, char *Heure, char *week_day, char *day, char *Minute, char *Annee);
void Display_Time(char Seconde, char Minute, char Heure);
void Display_Date(char week_day,char day, char Mois, char Annee) ;
void Write_Byte(unsigned char c2);


void interrupt()
 {
 if ((RCIE_bit) && (RCIF_bit))
 {
 c1 = RCREG;
 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 RCSTA.CREN = 1 ;
 CptErr++;
 c1 = RCREG;
 c1=0;
 }
 else
 if(RCSTA.FERR==1 )
 {
 CptErr++;
 c1=0;
 }
 else
 {
 c1 = RCREG;
 if ((c1== 13 ) || (i1>= 128 ))
 {
 Drapeaux.Full=1;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 }
 }

 if ((T0IE_bit)&&(TMR0IF_bit))
 {
 TMR0IF_bit = 0;
 TMR0H = 0x67;
 TMR0L = 0x69;
 Drapeaux.Elligible=1;
 Soft_I2C_Break();
 }
#line 546 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 }
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.h"







extern void Nokia_Init_Lcd(void);
extern void Nokia_SendCmd(char x);
extern void Nokia_SendData(char x);
extern void Nokia_Erase_Line(int L);
extern void Nokia_Clear(void);
extern void Nokia_Write_Char_At(char Col,char Lig, unsigned char c);


extern void Nokia_Chr_8x7(char Lx,char Cx, char charsel);
extern void Nokia_SendChar(char x);
extern void Nokia_SendPack(char x);
extern void Nokia_Text_Lig_Col(int y, int x, char size, unsigned char  *caracter);
extern void NOKIA_CText_5x7(char L,char C, const char *TxT);
extern void NOKIA_CText_8x7(char L,char C, const char *txt);

extern void Nokia_Raz_Ram_Video(void) ;
extern void Nokia_Goto_xy(char xnokia, char ynokia) ;
extern void Nokia_Pos_Lig_Col( char Lig, char Col, char size);
extern void Nokia_Put_Pixel (char x, char y, char color) ;
extern void Nokia_Bitmap(unsigned char x, unsigned char y, unsigned char * bitmap, unsigned char height,unsigned char width);
extern void Nokia_Print_Ram_Video(void);
extern void Nokia_Partial_Image(char xNOKIA, char yNOKIA, char xImage, char array_length, const char *image);
extern void Nokia_Image_96x64(const char *image) ;

extern void Nokia_Text(int x, int y, char size, char *caracter);
extern void Nokia_Line (char x1, char y1, char x2, char y2, char color);
extern void Nokia_Rect (char x1, char y1, char x2, char y2, char color);
extern void Bargraph (int V , int ligne);


const char table[480] = {
0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x5f,0x00,0x00,
0x00,0x07,0x00,0x07,0x00,
0x14,0x7f,0x14,0x7f,0x14,
0x24,0x2a,0x7f,0x2a,0x12,
0x23,0x13,0x08,0x64,0x62,
0x36,0x49,0x55,0x22,0x50,
0x00,0x05,0x03,0x00,0x00,
0x00,0x1c,0x22,0x41,0x00,
0x00,0x41,0x22,0x1c,0x00,
0x14,0x08,0x3e,0x08,0x14,
0x08,0x08,0x3e,0x08,0x08,
0x00,0x50,0x30,0x00,0x00,
0x08,0x08,0x08,0x08,0x08,
0x00,0x60,0x60,0x00,0x00,
0x20,0x10,0x08,0x04,0x02,
0x3e,0x51,0x49,0x45,0x3e,
0x00,0x42,0x7f,0x40,0x00,
0x42,0x61,0x51,0x49,0x46,
0x21,0x41,0x45,0x4b,0x31,
0x18,0x14,0x12,0x7f,0x10,
0x27,0x45,0x45,0x45,0x39,
0x3c,0x4a,0x49,0x49,0x30,
0x01,0x71,0x09,0x05,0x03,
0x36,0x49,0x49,0x49,0x36,
0x06,0x49,0x49,0x29,0x1e,
0x00,0x36,0x36,0x00,0x00,
0x00,0x56,0x36,0x00,0x00,
0x08,0x14,0x22,0x41,0x00,
0x14,0x14,0x14,0x14,0x14,
0x00,0x41,0x22,0x14,0x08,
0x02,0x01,0x51,0x09,0x06,
0x32,0x49,0x79,0x41,0x3e,
0x7e,0x11,0x11,0x11,0x7e,
0x7f,0x49,0x49,0x49,0x36,
0x3e,0x41,0x41,0x41,0x22,
0x7f,0x41,0x41,0x22,0x1c,
0x7f,0x49,0x49,0x49,0x41,
0x7f,0x09,0x09,0x09,0x01,
0x3e,0x41,0x49,0x49,0x7a,
0x7f,0x08,0x08,0x08,0x7f,
0x00,0x41,0x7f,0x41,0x00,
0x20,0x40,0x41,0x3f,0x01,
0x7f,0x08,0x14,0x22,0x41,
0x7f,0x40,0x40,0x40,0x40,
0x7f,0x02,0x0c,0x02,0x7f,
0x7f,0x04,0x08,0x10,0x7f,
0x3e,0x41,0x41,0x41,0x3e,
0x7f,0x09,0x09,0x09,0x06,
0x3e,0x41,0x51,0x21,0x5e,
0x7f,0x09,0x19,0x29,0x46,
0x46,0x49,0x49,0x49,0x31,
0x01,0x01,0x7f,0x01,0x01,
0x3f,0x40,0x40,0x40,0x3f,
0x1f,0x20,0x40,0x20,0x1f,
0x3f,0x40,0x38,0x40,0x3f,
0x63,0x14,0x08,0x14,0x63,
0x07,0x08,0x70,0x08,0x07,
0x61,0x51,0x49,0x45,0x43,
0x00,0x7f,0x41,0x41,0x00,
0x02,0x04,0x08,0x10,0x20,
0x00,0x41,0x41,0x7f,0x00,
0x04,0x02,0x01,0x02,0x04,
0x40,0x40,0x40,0x40,0x40,
0x00,0x01,0x02,0x04,0x00,
0x20,0x54,0x54,0x54,0x78,
0x7f,0x48,0x44,0x44,0x38,
0x38,0x44,0x44,0x44,0x20,
0x38,0x44,0x44,0x48,0x7f,
0x38,0x54,0x54,0x54,0x18,
0x08,0x7e,0x09,0x01,0x02,
0x0c,0x52,0x52,0x52,0x3e,
0x7f,0x08,0x04,0x04,0x78,
0x00,0x44,0x7d,0x40,0x00,
0x20,0x40,0x44,0x3d,0x00,
0x7f,0x10,0x28,0x44,0x00,
0x00,0x41,0x7f,0x40,0x00,
0x7c,0x04,0x18,0x04,0x78,
0x7c,0x08,0x04,0x04,0x78,
0x38,0x44,0x44,0x44,0x38,
0x7c,0x14,0x14,0x14,0x08,
0x08,0x14,0x14,0x18,0x7c,
0x7c,0x08,0x04,0x04,0x08,
0x48,0x54,0x54,0x54,0x20,
0x04,0x3f,0x44,0x40,0x20,
0x3c,0x40,0x40,0x20,0x7c,
0x1c,0x20,0x40,0x20,0x1c,
0x3c,0x40,0x30,0x40,0x3c,
0x44,0x28,0x10,0x28,0x44,
0x0c,0x50,0x50,0x50,0x3c,
0x44,0x64,0x54,0x4c,0x44,
0x00,0x08,0x36,0x41,0x00,
0x00,0x00,0x7f,0x00,0x00,
0x00,0x41,0x36,0x08,0x00,
0x10,0x08,0x08,0x10,0x08,
0x78,0x46,0x41,0x46,0x78};

const char Font_7_8 []={

 0, 0, 0, 0, 0, 0, 0,
 0, 6, 95, 95, 6, 0, 0,
 0, 7, 7, 0, 7, 7, 0,
 20, 127, 127, 20, 127, 127, 20,
 36, 46, 107, 107, 58, 18, 0,
 70, 102, 48, 24, 12, 102, 98,
 48, 122, 79, 93, 55, 122, 72,
 4, 7, 3, 0, 0, 0, 0,
 0, 28, 62, 99, 65, 0, 0,
 0, 65, 99, 62, 28, 0, 0,
 8, 42, 62, 28, 28, 62, 42,
 8, 8, 62, 62, 8, 8, 0,
 0, 128, 224, 96, 0, 0, 0,
 8, 8, 8, 8, 8, 8, 0,
 0, 0, 96, 96, 0, 0, 0,
 96, 48, 24, 12, 6, 3, 1,
 62, 127, 113, 89, 77, 127, 62,
 64, 66, 127, 127, 64, 64, 0,
 98, 115, 89, 73, 111, 102, 0,
 34, 99, 73, 73, 127, 54, 0,
 24, 28, 22, 83, 127, 127, 80,
 39, 103, 69, 69, 125, 57, 0,
 60, 126, 75, 73, 121, 48, 0,
 3, 3, 113, 121, 15, 7, 0,
 54, 127, 73, 73, 127, 54, 0,
 6, 79, 73, 105, 63, 30, 0,
 0, 0, 102, 102, 0, 0, 0,
 0, 128, 230, 102, 0, 0, 0,
 8, 28, 54, 99, 65, 0, 0,
 36, 36, 36, 36, 36, 36, 0,
 0, 65, 99, 54, 28, 8, 0,
 2, 3, 81, 89, 15, 6, 0,
 62, 127, 65, 93, 93, 31, 30,
 124, 126, 19, 19, 126, 124, 0,
 65, 127, 127, 73, 73, 127, 54,
 28, 62, 99, 65, 65, 99, 34,
 65, 127, 127, 65, 99, 62, 28,
 65, 127, 127, 73, 93, 65, 99,
 65, 127, 127, 73, 29, 1, 3,
 28, 62, 99, 65, 81, 115, 114,
 127, 127, 8, 8, 127, 127, 0,
 0, 65, 127, 127, 65, 0, 0,
 48, 112, 64, 65, 127, 63, 1,
 65, 127, 127, 8, 28, 119, 99,
 65, 127, 127, 65, 64, 96, 112,
 127, 127, 14, 28, 14, 127,127,
 127, 127, 6, 12, 24, 127,127,
 28, 62, 99, 65, 99, 62, 28,
 65, 127, 127, 73, 9, 15, 6,
 30, 63, 33, 113, 127, 94, 0,
 65, 127, 127, 9, 25, 127, 102,
 38, 111, 77, 89, 115, 50, 0,
 3, 65, 127, 127, 65, 3, 0,
 127, 127, 64, 64, 127, 127, 0,
 31, 63, 96, 96, 63, 31, 0,
 127, 127, 48, 24, 48, 127, 127,
 67, 103, 60, 24, 60, 103, 67,
 7, 79, 120, 120, 79, 7, 0,
 71, 99, 113, 89, 77, 103, 115,
 0, 127, 127, 65, 65, 0, 0,
 1, 3, 6, 12, 24, 48, 96,
 0, 65, 65, 127, 127, 0, 0,
 8, 12, 6, 3, 6, 12, 8,
 128, 128, 128, 128, 128,128, 128,
 0, 0, 3, 7, 4, 0, 0,
 32, 116, 84, 84, 60, 120, 64,
 65, 127, 63, 72, 72, 120, 48,
 56, 124, 68, 68, 108, 40, 0,
 48, 120, 72, 73, 63, 127, 64,
 56, 124, 84, 84, 92, 24, 0,
 72, 126, 127, 73, 3, 2, 0,
 56, 188, 164, 164, 252, 120, 0,
 65, 127, 127, 8, 4, 124, 120,
 0, 68, 125, 125, 64, 0, 0,
 96, 224, 128, 128, 253, 125, 0,
 65, 127, 127, 16, 56, 108, 68,
 0, 65, 127, 127, 64, 0, 0,
 120, 124, 28, 56, 28, 124, 120,
 124, 124, 4, 4, 124, 120, 0,
 56, 124, 68, 68, 124, 56, 0,
 0, 252, 252, 164, 36, 60, 24,
 24, 60, 36, 164, 248, 252, 132,
 68, 124, 120, 76, 4, 28, 24,
 72, 92, 84, 84, 116, 36, 0,
 0, 4, 62, 127, 68, 36, 0,
 60, 124, 64, 64, 60, 124, 64,
 28, 60, 96, 96, 60, 28, 0,
 60, 124, 112, 56, 112, 124, 60,
 68, 108, 56, 16, 56, 108, 68,
 60, 188, 160, 160, 252, 124, 0,
 76, 100, 116, 92, 76, 100, 0,
 8, 8, 62, 119, 65, 65, 0,
 0, 0, 0, 119, 119, 0, 0,
 65, 65, 119, 62, 8, 8, 0,
 2, 3, 1, 3, 2, 3, 1,
 255, 29, 129,129, 129, 129, 255,
 14, 159, 145, 177, 251, 74, 0
};


const char Font_3_6 []={
 0x00,0x00,0x00,
 0x00,0x5C,0x00,
 0x0C,0x00,0x0C,
 0x7C,0x28,0x7C,
 0x7C,0x44,0x7C,
 0x24,0x10,0x48,
 0x28,0x54,0x08,
 0x00,0x0C,0x00,
 0x38,0x44,0x00,
 0x44,0x38,0x00,
 0x20,0x10,0x08,
 0x10,0x38,0x10,
 0x80,0x40,0x00,
 0x10,0x10,0x10,
 0x00,0x40,0x00,
 0x20,0x10,0x08,
 0x38,0x44,0x38,
 0x00,0x7C,0x00,
 0x64,0x54,0x48,
 0x44,0x54,0x28,
 0x1C,0x10,0x7C,
 0x4C,0x54,0x24,
 0x38,0x54,0x20,
 0x04,0x74,0x0C,
 0x28,0x54,0x28,
 0x08,0x54,0x38,
 0x00,0x50,0x00,
 0x80,0x50,0x00,
 0x10,0x28,0x44,
 0x28,0x28,0x28,
 0x44,0x28,0x10,
 0x04,0x54,0x08,
 0x38,0x4C,0x5C,
 0x78,0x14,0x78,
 0x7C,0x54,0x28,
 0x38,0x44,0x44,
 0x7C,0x44,0x38,
 0x7C,0x54,0x44,
 0x7C,0x14,0x04,
 0x38,0x44,0x34,
 0x7C,0x10,0x7C,
 0x00,0x7C,0x00,
 0x20,0x40,0x3C,
 0x7C,0x10,0x6C,
 0x7C,0x40,0x40,
 0x7C,0x08,0x7C,
 0x7C,0x04,0x7C,
 0x7C,0x44,0x7C,
 0x7C,0x14,0x08,
 0x38,0x44,0x78,
 0x7C,0x14,0x68,
 0x48,0x54,0x24,
 0x04,0x7C,0x04,
 0x7C,0x40,0x7C,
 0x3C,0x40,0x3C,
 0x7C,0x20,0x7C,
 0x6C,0x10,0x6C,
 0x1C,0x60,0x1C,
 0x64,0x54,0x4C,
 0x7C,0x44,0x00,
 0x08,0x10,0x20,
 0x44,0x7C,0x00,
 0x08,0x04,0x08,
 0x80,0x80,0x80,
 0x04,0x08,0x00
};

const char Font_5_7 []={
 0x00,0x00,0x00,0x00,0x00,
 0x00,0x00,0x5f,0x00,0x00,
 0x00,0x07,0x00,0x07,0x00,
 0x14,0x7f,0x14,0x7f,0x14,
 0x24,0x2a,0x7f,0x2a,0x12,
 0x23,0x13,0x08,0x64,0x62,
 0x36,0x49,0x55,0x22,0x50,
 0x00,0x05,0x03,0x00,0x00,
 0x00,0x1c,0x22,0x41,0x00,
 0x00,0x41,0x22,0x1c,0x00,
 0x14,0x08,0x3e,0x08,0x14,
 0x08,0x08,0x3e,0x08,0x08,
 0x00,0x50,0x30,0x00,0x00,
 0x08,0x08,0x08,0x08,0x08,
 0x00,0x60,0x60,0x00,0x00,
 0x20,0x10,0x08,0x04,0x02,
 0x3e,0x51,0x49,0x45,0x3e,
 0x00,0x42,0x7f,0x40,0x00,
 0x42,0x61,0x51,0x49,0x46,
 0x21,0x41,0x45,0x4b,0x31,
 0x18,0x14,0x12,0x7f,0x10,
 0x27,0x45,0x45,0x45,0x39,
 0x3c,0x4a,0x49,0x49,0x30,
 0x01,0x71,0x09,0x05,0x03,
 0x36,0x49,0x49,0x49,0x36,
 0x06,0x49,0x49,0x29,0x1e,
 0x00,0x36,0x36,0x00,0x00,
 0x00,0x56,0x36,0x00,0x00,
 0x08,0x14,0x22,0x41,0x00,
 0x14,0x14,0x14,0x14,0x14,
 0x00,0x41,0x22,0x14,0x08,
 0x02,0x01,0x51,0x09,0x06,
 0x32,0x49,0x79,0x41,0x3e,
 0x7e,0x11,0x11,0x11,0x7e,
 0x7f,0x49,0x49,0x49,0x36,
 0x3e,0x41,0x41,0x41,0x22,
 0x7f,0x41,0x41,0x22,0x1c,
 0x7f,0x49,0x49,0x49,0x41,
 0x7f,0x09,0x09,0x09,0x01,
 0x3e,0x41,0x49,0x49,0x7a,
 0x7f,0x08,0x08,0x08,0x7f,
 0x00,0x41,0x7f,0x41,0x00,
 0x20,0x40,0x41,0x3f,0x01,
 0x7f,0x08,0x14,0x22,0x41,
 0x7f,0x40,0x40,0x40,0x40,
 0x7f,0x02,0x0c,0x02,0x7f,
 0x7f,0x04,0x08,0x10,0x7f,
 0x3e,0x41,0x41,0x41,0x3e,
 0x7f,0x09,0x09,0x09,0x06,
 0x3e,0x41,0x51,0x21,0x5e,
 0x7f,0x09,0x19,0x29,0x46,
 0x46,0x49,0x49,0x49,0x31,
 0x01,0x01,0x7f,0x01,0x01,
 0x3f,0x40,0x40,0x40,0x3f,
 0x1f,0x20,0x40,0x20,0x1f,
 0x3f,0x40,0x38,0x40,0x3f,
 0x63,0x14,0x08,0x14,0x63,
 0x07,0x08,0x70,0x08,0x07,
 0x61,0x51,0x49,0x45,0x43,
 0x00,0x7f,0x41,0x41,0x00,
 0x02,0x04,0x08,0x10,0x20,
 0x00,0x41,0x41,0x7f,0x00,
 0x04,0x02,0x01,0x02,0x04,
 0x40,0x40,0x40,0x40,0x40,
 0x00,0x01,0x02,0x04,0x00,
 0x20,0x54,0x54,0x54,0x78,
 0x7f,0x48,0x44,0x44,0x38,
 0x38,0x44,0x44,0x44,0x20,
 0x38,0x44,0x44,0x48,0x7f,
 0x38,0x54,0x54,0x54,0x18,
 0x08,0x7e,0x09,0x01,0x02,
 0x0c,0x52,0x52,0x52,0x3e,
 0x7f,0x08,0x04,0x04,0x78,
 0x00,0x44,0x7d,0x40,0x00,
 0x20,0x40,0x44,0x3d,0x00,
 0x7f,0x10,0x28,0x44,0x00,
 0x00,0x41,0x7f,0x40,0x00,
 0x7c,0x04,0x18,0x04,0x78,
 0x7c,0x08,0x04,0x04,0x78,
 0x38,0x44,0x44,0x44,0x38,
 0x7c,0x14,0x14,0x14,0x08,
 0x08,0x14,0x14,0x18,0x7c,
 0x7c,0x08,0x04,0x04,0x08,
 0x48,0x54,0x54,0x54,0x20,
 0x04,0x3f,0x44,0x40,0x20,
 0x3c,0x40,0x40,0x20,0x7c,
 0x1c,0x20,0x40,0x20,0x1c,
 0x3c,0x40,0x30,0x40,0x3c,
 0x44,0x28,0x10,0x28,0x44,
 0x0c,0x50,0x50,0x50,0x3c,
 0x44,0x64,0x54,0x4c,0x44,
 0x00,0x08,0x36,0x41,0x00,
 0x00,0x00,0x7f,0x00,0x00,
 0x00,0x41,0x36,0x08,0x00,
 0x10,0x08,0x08,0x10,0x08,
 0x78,0x46,0x41,0x46,0x78,


 };




unsigned char Ram_Video[768];
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
#line 19 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
extern float F1;
extern *table;
extern *Ram_Video;
extern *txt;
extern char Ligne18cars;

void Nokia_Init_Lcd(void);
void Nokia_SendCmd(char x);
void Nokia_SendData(char x);
void Nokia_Erase_Line(int L);
void Nokia_Clear(void);
void Nokia_Write_Char_At(char Lig,char Col, unsigned char c);
void Bargraph (int V , int ligne);

void Nokia_Chr_8x7(char Lx,char Cx, char charsel);
void Nokia_SendChar(char x);
void Nokia_SendPack(char x);
void Nokia_Text_Lig_Col(int y, int x, char size, unsigned char  *caracter);
void Nokia_CText_5x7(char L,char C, const char *TxT);
void Nokia_CText_8x7(char L,char C, const char *txt);

void Nokia_Raz_Ram_Video(void) ;
void Nokia_Goto_xy(char xnokia, char ynokia) ;
void Nokia_Pos_Lig_Col( char Lig, char Col,char size);

void Nokia_Put_Pixel (char x, char y, char color) ;
void Nokia_Partial_Image(char xNOKIA, char yNOKIA, char xImage, char array_length, const char *image);

void Nokia_Bitmap(unsigned char x, unsigned char y, unsigned char * bitmap, unsigned char height,unsigned char width);
void Nokia_Print_Ram_Video(void);
void Nokia_Image_96x64(const char *image) ;

void Nokia_Rectangle (char x1, char y1, char x2, char y2, char color);
void Nokia_Bitmap_xy (int x, int y, char *bitmap, int height, int width);

void Nokia_Line (char x1, char y1, char x2, char y2, char color);
void Nokia_Rect (char x1, char y1, char x2, char y2, char color);


void Nokia_Goto_xy(char xnokia, char ynokia)
{
 Nokia_SendCmd(0x40|(ynokia&0x07));
 Nokia_SendCmd(0x80|(xnokia&0x7f));
 }

void Nokia_Pos_Lig_Col( char Lig, char Col, char size)
{
 unsigned char C;
 C=Col-1;
 Nokia_SendCmd(0x40|((Lig-1) & 0x07));
 switch(size)
 {
 case 1:Nokia_SendCmd(0x80|((C*3)& 0x7f)); break;
 case 2:Nokia_SendCmd(0x80|((C*5)& 0x7f)); break;
 case 3:Nokia_SendCmd(0x80|((C*7)& 0x7f)); break;
 }

}


void Nokia_Init_Lcd(void)
{
 LATC.B2  =1;
 LATC.B0  =1;
 LATC.B2  =0;
Delay_ms(200);
 LATC.B2 =1;
Nokia_SendCmd(0x21);
Nokia_SendCmd(0x90);
Nokia_SendCmd(0x05);
Nokia_SendCmd(0x13);
Nokia_SendCmd(0x20);
Delay_ms(10);
Nokia_SendCmd(0x0C);
Nokia_Clear();
Delay_ms(100);
Nokia_SendCmd(0x40);
Nokia_SendCmd(0x80);
}

void Nokia_SendCmd(char x)
{
 LATC.B1 = 0;
 LATC.B0 =0;
Nokia_SendPack(x);
Delay_ms(1);
 LATC.B0 =1;
return;
}

void Nokia_SendData(char x)
{
 LATC.B1 = 1;
 Delay_us(2);
 LATC.B0 =0;
 Delay_us(2);
Nokia_SendPack(x);
 LATC.B0 =1;
}

void Nokia_SendPack(char x)
{ int i;
 for(i=0;i<8;i++)
 {
  LATC.B3 =0;
 Delay_us(2);

 if ((x&0x80)==0x80)  LATC.B4 =1; else  LATC.B4 =0;
 Delay_us(2);
  LATC.B3 =1;
 x=x<<1;
 Delay_us(2);
 }
}

void Nokia_Erase_Line(int L)
{
 int i,j;
 Nokia_Pos_Lig_Col(L,0,2);
 Delay_ms(10);
 i=(L-1)*96;;
 j=i+96;
 for(L=i;L<j;L++)
 {
 Nokia_SendData(0x00);
 Delay_ms(1);
 }
 Nokia_Pos_Lig_Col(L,0,2);
 Delay_ms(2);
}


void Nokia_Erase_Line_(int L)
{

 Nokia_Goto_xy(L,0);
 Nokia_CText_5x7(L,0,"                ");
 Nokia_Goto_xy(L,0);
}


void Nokia_Clear(void)
{
 int i;
 Nokia_SendCmd(0x40);
 Nokia_SendCmd(0x80);
 Delay_ms(10);
 for(i=0;i<768;i++)
 {
 Nokia_SendData(0x00);
 Delay_ms(1);
 }
}



void Bargraph (int V , int ligne)
{
 unsigned int i,j,m;
 F1= (float)V *96.0/1024.0;
 m=(unsigned int)F1;
 if ((ligne>0) && (ligne<9))
 {
 Nokia_SendCmd(0x40|((ligne-1) & 0x07));
 for (i=0;i<94;i++)
 {
 Nokia_SendCmd(0x80|i);
 if (i<=m) Nokia_SendData(0x3C); else Nokia_SendData(0x00);
 Delay_us(5);
 }
 Nokia_SendCmd(0x40|((ligne-1) & 0x07));
 }
 }





void Nokia_Write_Char_At(char Lig,char Col, unsigned char cc)
 { char Cl;
 Cl=Col;

 Nokia_SendCmd(0x40|((Lig-1) & 0x07));
 if (Ligne18Cars==1)
 Nokia_SendCmd(0x80|((Cl*5)& 0x7f));
 else
 Nokia_SendCmd(0x80|((Cl*6)& 0x7f));
 Nokia_SendChar(cc);
 }


void Nokia_SendChar(char x)
{
 int a,b;
 char c;

 if((x<0x20)||(x>0x7f)) return;


 a=(5*x)-160;
 for (b=0;b<5;b++)

 {
 c=table[a];
 Nokia_SendData(c);
 a++;
 }
 Nokia_SendData(0x00);
}


 void Nokia_CText_5x7(char L1,char C1,const char * txt)
 {
 unsigned char posX,cx ;
 posX=C1-1;
 Nokia_SendCmd(0x40|((L1-1) & 0x07));
 Nokia_SendCmd(0x80|((posX*5) & 0x7f));
 if (L1>8) return ;
 while(*(txt)>0)
 {
 if (posX>16) break;
 cx=*(txt++);
 Nokia_SendChar(cx);
 posX++;
 }
 }



void Nokia_Raz_Ram_Video(void)
{
 int ddram;
 Nokia_SendCmd(0x40);
 Nokia_SendCmd(0x80);
 for (ddram=0;ddram<768;ddram++) Ram_Video[ddram]=0;
}

void Nokia_Print_Ram_Video(void)
{
 int ddram;
 Nokia_SendCmd(0x40);
 Nokia_SendCmd(0x80);
 for (ddram=0;ddram<768;ddram++) Nokia_SendData(Ram_Video[ddram]);
}


void Nokia_Put_Pixel (char x, char y, char color)
{
 int idx;
 idx = ((int)(y/8) * 96) + x;
 if (color)
 Ram_Video[idx] = Ram_Video[idx] | (1<< (y % 8));
 else
 Ram_Video[idx] = Ram_Video[idx] & (0xFF - (1<< (y % 8)));
}


void Nokia_Image_96x64(const char *image)

{
int i,j,x;
 unsigned int k;
 unsigned char masque;
 unsigned char cx;
 Nokia_SendCmd(0x40);
 Nokia_SendCmd(0x80);
#line 288 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
 for (j=0;j<64;j++)
 {
 for (i=0;i<12;i++)
 {
 k=i+j*12 ;
 cx= image[k];
 masque = 0x80;
 x=0;
 while (masque > 0 )
 {
 k=i*8+x;
 if ((cx & masque)==masque)
 {
#line 304 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
 Nokia_Put_Pixel(k,j,1);
 }
 else
 {
#line 311 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
 Nokia_Put_Pixel(k,j,0);
 }
 masque =masque /2;
 x++;
 Delay_us(20);
 }
 }
#line 322 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/mylib_nokia_96x64.c"
 }
}

void Nokia_Chr_8x7(char Lx,char Cx, char charsel)
{
 char char_row;
 char data1;
 int charposition;
 Nokia_SendCmd(0x40|((Lx-1) & 0x07));
 Nokia_SendCmd(0x80|(((Cx-1)*8) & 0x7f));
 if (charsel<0x20) return;
 if (charsel>0x7f) return;
 for(char_row=0;char_row<7;char_row++)
 {
 charposition=(((charsel&0x7f)-0x20)*7);
 data1= Font_7_8[charposition+char_row];
 Nokia_SendData(data1);

 }
 Delay_us(2);
 Nokia_SendData(0x00);
}


 void Nokia_CText_8x7(char Lt,char Ct, const char *txt1)
 {
 unsigned char posX,posY;
 posX=Ct;
 posY=Lt;
 if (Lt>8) return;
 while(*(txt1)>0)
 {
 if (posX>12)break;
 Nokia_Chr_8x7(posY,posX,*(txt1++));
 posX++;
 }
 }




void Nokia_Line (char x1, char y1, char x2, char y2, char color)
{
 char DeltaX, DeltaY,MinX,MinY,MaxX,MaxY,DeltaMax,i,xx,yy;
 float OffsetX, OffsetY;
 if (y1>y2)
 {MinY=y2;MaxY=y1;OffsetY=-1.0;}
 else
 {MinY=y1;MaxY=y2;OffsetY=1.0;}
 if (y1==y2) OffsetY=0;
 if (x1>x2)
 {MinX=x2;MaxX=x1;OffsetX=-1.0;}
 else
 {MinX=x1;MaxX=x2;OffsetX=1.0;}
 if (x1==x2) OffsetX=0;
 DeltaX = MaxX-MinX+1;
 DeltaY = MaxY-MinY+1;
 if (DeltaX>DeltaY)
 {
 OffsetY = (float)DeltaY / (float)DeltaX * OffsetY;
 DeltaMax=DeltaX;
 }
 else
 {
 OffsetX = (float)DeltaX / (float)DeltaY * OffsetX;
 DeltaMax=DeltaY;
 }
 for (i=0;i<DeltaMax;i++)
 {
 xx=x1 + OffsetX * i;
 yy=y1 + OffsetY * i;
 if ((xx<96) && (yy<64) && (xx>=0) && (yy>=0))
 Nokia_Put_Pixel (xx,yy, color);
 }
}



void Nokia_Rect (char x1, char y1, char x2, char y2, char color)
{
 int i;
 Nokia_Line (x1,y1,x2,y1,color);
 Nokia_Line (x1,y2,x2,y2,color);
 Nokia_Line (x2,y1,x2,y2,color);
 Nokia_Line (x1,y1,x1,y2,color);

}
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/my_24lc256_eeprom.h"








extern void Write_Byte_To_24LC512(unsigned int Adr, unsigned char cx) ;
extern unsigned char Read_Byte_from_24LC512(unsigned int Adr) ;
extern void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg);
extern void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg) ;
extern void Save_Date_Time_To_24LC512(void) ;
#line 1 "c:/_mikroc/_mesprojets_mikroc/_18f4685_platine_nokia_40mhz_2016/my_24lc256_eeprom.c"




void Write_Byte_To_24LC512(unsigned int Adr, unsigned char cx) ;
unsigned char Read_Byte_from_24LC512(unsigned int Adr) ;
void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg);
void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg) ;
void Save_Date_Time_To_24LC512(void) ;


void Write_Byte_To_24LC512(unsigned int Adr, unsigned char cx)
{
 Soft_I2C_Start() ;
 err=Soft_I2C_Write ( 0xA0  );
 err=Soft_I2C_Write (Adr>>8);
 err=Soft_I2C_Write (Adr& 0x00FF);
 err=Soft_I2C_Write (cx);
 Soft_I2C_Stop ();
Delay_ms(5);
 }

unsigned char Read_Byte_from_24LC512(unsigned int Adr)
{
unsigned char c3;
 Soft_I2C_Start() ;
 err=Soft_I2C_Write ( 0xA0  );
 err=Soft_I2C_Write (Adr>>8);
 err=Soft_I2C_Write (Adr&0x00FF);
 Soft_I2C_Stop ();
 Soft_I2C_Start() ;
Delay_ms(1);
 err=Soft_I2C_Write ( 0xA0 +1 );
c3= Soft_I2C_Read (0u);
 Soft_I2C_Stop ();
return c3;
}

void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg)
{int i;
 for (i=0;i<Lg;i++)
 {
 *(t+i)=Read_Byte_from_24LC512(Adr+i);
 Delay_ms(1);
 }
 }

void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg)
{ int i;
 for (i=0;i<lg;i++)
 {
 Write_Byte_To_24LC512(Adr+i, *(t+i)) ;
 Delay_ms(5);
 }
}

void Save_Date_Time_To_24LC512()
{
GIE_bit=0;
 Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Write_Byte_To_24LC512(Index,Mois); Index++;
 Write_Byte_To_24LC512(Index,day); Index++;
 Write_Byte_To_24LC512(Index,Heure); Index++;
 Write_Byte_To_24LC512(Index,Minute); Index++;
 Write_Byte_To_24LC512(Index,Seconde); Index++;
 Write_Byte_To_24LC512(Index,13);
 GIE_bit=1;
}
#line 618 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
unsigned char EEPROM_Lect(unsigned int AdrL)
{
 EEADR =(unsigned char)(AdrL &0x00FF);
 EEADRH =(unsigned char) ((AdrL >>8) & 0x0003);
 EECON1.EEPGD=0;
 Delay_ms(1);
 EECON1.CFGS=0;
 EECON1.RD=1;
 Delay_ms(20);;
 return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car)
{int dr=0;
 EEADR =AdrE & 0xFF;
 EEADRH = (AdrE>>8)& 0x03;
 EEDATA=car;
 EECON1.EEPGD=0;
 EECON1.WREN=1;
 EECON1.CFGS =0;
 if(INTCON.GIE ==1)
 {
 INTCON.GIE =0 ;
 dr=1;
 }
 EECON2=0x55;
 EECON2=0xAA;
 EECON1.WR=1;
 while (PIR2.EEIF==0);
 PIR2.EEIF=0;
 EECON1.WREN=0;
 if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int adrx, unsigned char * ptr1)
{
 while (*ptr1)
 {
 EEPROM_Ecr(adrx++,*ptr1++);
 if (adrx>1023) break;
 }
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
 do
 {
 if ( PtrE >1023) break;
 c = EEPROM_Lect(PtrE);
 if ( c==0) break;
 UART1_Write(c);
 PtrE++;
 }
 while (c!=0) ;
 Delay_ms(100);
}

void RAZ_PIC_EEPROM()
{

 for(k=0;k<1023;k++)
 {
 EEPROM_Ecr(k,0x20);
 }
 }

void Relit_PIC_Eeprom()
{
unsigned int i,ind,dr;
char c1;
if(GIE_bit==1) dr=1;
INTCON.GIE =0 ;
i=(unsigned int)EEPROM_Lect(0)<< 8 ;
ind = i +(unsigned int)EEPROM_Lect(1);
k=sprintf(txt,"Lecture Eeprom PIC  Ix=%05d\r\n",ind);
UART1_Write_Text(txt);
k=sprintf(txt,"Nb_Watt;Temp_ext;Nb_Chauffes\r\n");
UART1_Write_Text(txt);
if (ind>1023) return;
for (i=2;i<ind;i++)
{
 c1=EEPROM_Lect(i);
 UART1_Write(c1);
}
CRLF1();

if(buffer1[0]=='L')
{
 buffer1[0]=0;
 CptErr=0;
 Drapeaux.Full=0;
 PIE1.RCIE = 1;
 i1=0;
}
if(dr==1) INTCON.GIE =1 ;
}





void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}

unsigned char *Float2Ascii (float x, unsigned char *str,char precision)
{


 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 adpt=str;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
return (adpt);
}



void Init_DS1307()
{
 Seconde=0x00;
 Minute=0x59;
 Heure=0x16 ;
 day=0x25;
 Mois=0x04;
 week_day=0x01;
 Annee=0x16;
 Write_Time();
}

void Write_Time()
 {
  Soft_I2C_Start() ;
  err=Soft_I2C_Write ( 0xD0 );
  err=Soft_I2C_Write (0);
  err=Soft_I2C_Write (0x80);
  err=Soft_I2C_Write (Minute);
  err=Soft_I2C_Write (Heure);
  err=Soft_I2C_Write (week_day);
  err=Soft_I2C_Write (day);
  err=Soft_I2C_Write (Mois);
  err=Soft_I2C_Write (Annee);
  Soft_I2C_Stop ();

  Soft_I2C_Start() ;
 Delay_ms(10);
  err=Soft_I2C_Write ( 0xD0 );
  err=Soft_I2C_Write (0);
  err=Soft_I2C_Write (0);
  Soft_I2C_Stop ();
}

void Read_Time(char *Seconde, char *Minute, char *Heure, char *week_day, char *day, char *Mois, char *Annee)
 {
  Soft_I2C_Start() ;
  err=Soft_I2C_Write ( 0xD0 );
  err=Soft_I2C_Write (0);
  Soft_I2C_Stop ();
  Soft_I2C_Start() ;
 Delay_ms(5);
  err=Soft_I2C_Write (0xD1);
 Delay_ms(1);
 *Seconde = Soft_I2C_Read (1);
 *Minute = Soft_I2C_Read (1);
 *Heure = Soft_I2C_Read (1);
 *week_day = Soft_I2C_Read (1);
 *day = Soft_I2C_Read (1);
 *Mois = Soft_I2C_Read (1);
 *Annee = Soft_I2C_Read (0);
  Soft_I2C_Stop ();
}

void Transform_Time(char *Seconde, char *Minute, char *Heure, char *week_day, char *day, char *Mois, char *Annee)
 {
 *Seconde = ((*Seconde & 0x7F) >> 4)*10 + (*Seconde & 0x0F);
 *Minute = ((*Minute & 0xF0) >> 4)*10 + (*Minute & 0x0F);
 *Heure = ((*Heure & 0x30) >> 4)*10 + (*Heure & 0x0F);
 *week_day =(*week_day & 0x07);
 *day = ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
 *Mois = ((*Mois & 0x10) >> 4)*10 + (*Mois & 0x0F);
 *Annee = ((*Annee & 0xF0)>>4)*10+(*Annee & 0x0F);
}



void Display_Time(char Seconde, char Minute, char Heure)
{ Drapeaux.Lcd=1;
 Nokia_Pos_Lig_Col(1,1,2) ;
 strConstRamCpy(txt,"Time: ");
 Write_String(txt);
 redirige_RS232(0,txt);
 Drapeaux.Lcd=1;
 Nokia_Write_Char_At(1,7,(Heure / 10) + 48);
 Nokia_Write_Char_At(1,8,(Heure % 10) + 48);
 Nokia_Write_Char_At(1,9,':');
 Nokia_Write_Char_At(1,10,(Minute / 10) + 48);
 Nokia_Write_Char_At(1,11,(Minute % 10) + 48);
 Nokia_Write_Char_At(1,12,':');
 Nokia_Write_Char_At(1,13,(Seconde / 10) + 48);
 Nokia_Write_Char_At(1,14,(Seconde % 10) + 48);
 Nokia_Write_Char_At(1,15,'.');

 Drapeaux.Lcd=0;
 DateTime[4]=Heure; ByteToStr( Heure,CRam0); UART1_Write_Text( CRam0);UART1_Write(':');
 DateTime[5]=Minute; ByteToStr( Minute,CRam0); UART1_Write_Text( CRam0); UART1_Write(':');
 DateTime[6]=Seconde; ByteToStr( Seconde,CRam0); UART1_Write_Text( CRam0);
 UART1_Write(';');

 }

 void Display_Date(char week_day,char day, char Mois, char Annee)
 {
 Drapeaux.Lcd=1;
 Nokia_Pos_Lig_Col(2,1,2) ;

 ByteToStr(week_day,txt);UART1_Write_Text(txt);UART1_Write( 9 );
 strConstRamCpy(txt,JS[week_day]);

 Write_String(txt);
 redirige_RS232(0,txt);
 Drapeaux.Lcd=1;

 Nokia_Write_Char_At(2,6,(day / 10) + 48);
 Nokia_Write_Char_At(2,7, (day % 10) + 48);
 Nokia_Write_Char_At(2,8,'/');
 Nokia_Write_Char_At(2,9,(Mois / 10) + 48);
 Nokia_Write_Char_At(2,10,(Mois % 10) + 48);
 Nokia_Write_Char_At(2,11,'/');
 Nokia_Write_Char_At(2,12,'2');
 Nokia_Write_Char_At(2,13,'0');
 Nokia_Write_Char_At(2,14, (Annee / 10) + 48);
 Nokia_Write_Char_At(2,15, (Annee % 10) + 48);
 Drapeaux.Lcd=0;
 DateTime[0]=day;ByteToStr(day,CRam1); UART1_Write_Text( CRam1); UART1_Write('/');
 DateTime[1]=Mois;ByteToStr( Mois,CRam1); UART1_Write_Text( CRam1); UART1_Write('/');

 DateTime[2]=Annee;ByteToStr(Annee,CRam1); UART1_Write_Text( CRam1);
 DateTime[3]=week_day;
 UART1_Write(';');

}


void MAJ_RTC()
{ int m,l,j,i;
 PIE1.RCIE = 0;
 m=2;
 j=0;


 CRLF1();
 l=strlen(buffer1);
 WordToStr(l,CRam0);
 UART1_Write_Text(CRam0);
 CRLF1();



 if ((buffer1[0]=='U')&& (buffer1[l-1]=='#') && (l>=19))
 {
 UART1_Write_CText("\n\rMise a l'heure RTC \r\n");
 for (i=2;i<l;i++)
 {
 if(buffer1[i]==';')
 {
 buffer1[i]=0;
 DateTime[j]=atoi(buffer1+m);
 m=i+1;
 j++;
 }
 }

 buffer1[l-1]=0;
 DateTime[j]=atoi(buffer1+m);
 day=Dec2Bcd(DateTime[0]);
 Mois=Dec2Bcd(DateTime[1]);
 Annee=Dec2Bcd(DateTime[2]);
 week_day=Dec2Bcd(DateTime[3]);
 Heure=Dec2Bcd(DateTime[4]);
 Minute=Dec2Bcd(DateTime[5]);
 Write_Time();
 buffer1[0]=0;

 j=0;
 CptErr=0;
 Drapeaux.Full=0;

 }
 PIE1.RCIE = 1;
 }





void redirige_RS232(int wcr, unsigned char *T)
 {
 Drapeaux.Lcd=0;
 Write_String(T);
 if (wcr==1)
 {
 UART1_Write(10);
 UART1_Write(13);
 }
 Drapeaux.Lcd=1;
 }

void Write_String(unsigned char *T)
{
short int i1,j1,k;
 j1=strlen(T);
 i1=0;
 do
 {
 k=T[i1];
 if (Drapeaux.Lcd==0)
 UART1_Write(k);
 else
 Nokia_SendChar(k);
 i1++;
 }while (i1<j1);
}
 void CRLF1()
 {
 UART1_Write(13);
 UART1_Write(10);
 }


void strConstRamCpy(unsigned char *dest, const code char *source) {
 while (*source)
 {*dest = *source ;
 dest ++ ;
 source ++;
 }
 *dest = 0 ;
}

void My_ADC_Init()
{
 ADCON0=0;
 ADCON0.ADON=1;
 ADCON1 = 0x1B;
 ADCON1.VCFG1=0;
 ADCON1.VCFG0=1;

 ADCON1.PCFG3= 1;
 ADCON1.PCFG2= 0;
 ADCON1.PCFG1= 1;
 ADCON1.PCFG0= 1;

 ADCON2.ADFM=1;

 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;

 ADCON2.ADCS2=1;
 ADCON2.ADCS1=0;
 ADCON2.ADCS0=1;
}


unsigned int My_ADC_Read(unsigned char channel)
{
 int i;
 unsigned int RawM, avg_output=0,temp=0 ;
 if(channel > 7) return 0;
 ADCON0 =ADCON0 & 0x03;
 ADCON0 =ADCON0 | channel<<2;
 Delay_ms(3);
 GO_bit = 1;
 _asm NOP
 while(GO_bit);
 RawM=(unsigned int) (ADRESH<<8) + ADRESL ;
return(RawM);
}

 void Init_Timer0()
 {
 T0CON = 0x85;
 TMR0H = 0x67;
 TMR0L = 0x69;
 GIE_bit = 1;
 TMR0IE_bit = 1;
 }
#line 1069 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
void Save_Index_24LC512()
{
 unsigned char cx;
 cx=Index >>8;
 Write_Byte_To_24LC512(0,cx);
 Delay_ms(10);
 cx=(unsigned char) (Index & 0x00FF);
 Write_Byte_To_24LC512(1,cx);
 Delay_ms(10);
}


void Aide()
{
int i;
 for (i=0;i<8;i++)
 {
 UART1_Write_CText(HELP[i]);
 CRLF1();
 Nokia_CText_5x7(i,1,HELP[i]);
 }
}





void main()
{

 PORTB = 0x00;
 TRISB = 0xFD;
 INIT_RTC_Direction=1;
 RBPU_bit=0;

 PORTA = 0xFF;
 TRISA = 0xFF;
 TRISD=0x00;

 PORTC = 0xFE;
 TRISC = 0xC0;
 TRISE=0;
 PORTE=0xFF;
  PORTE.F1 =1;



 My_ADC_Init();

 Drapeaux.Lcd=0;
 Delay_ms(200);
  PORTE.F1 =0;

 UART1_Init(57600);
 Delay_ms(500);
 UART1_Write( 12 );
 Delay_ms(100);
 CRLF1();

 UART1_Write_CText( "Mikroc Pro 6.62\r\n");
 UART1_Write_CText( "Projet : " "18F4685_Platine_Nokia_160426_40Mhz.mcppi" " \r\n");
 UART1_Write_CText( "Platine Nokia LCD 96x64 pixels PIC 18F4685 96K :\r\n " "18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz" "_" "160426" ".c\r\n");
 UART1_Write_CText( "Utilise MyLib_Nokia_96x64.H et MyLib_Nokia_96x64.c \r\n");
 txt=&TEXTE[0];



 UART1_Write_CText("Attention : Tinybootloader V1.98  limite EEPROM  256 bytes ! not 1024 \r\n");


 PrintOut_Eeprom_Msg(0x0000);
#line 1152 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 UART1_Write_CText("Vecteur Start Bootloader en  0x17F38=  ");


 for (i=0;i<4;i++)
 {
 c1=FLASH_Read(0x17F38+i);
 ByteToHex(c1,txt);
 UART1_Write_Text(txt);
 }
 CRLF1();
 c1= FLASH_Read(0x17F38+2);


 c2= FLASH_Read(0x17F38);
 k=(int) c1 << 8 ;
 k=k + c2;
 k=k<<1;



 sprintf(txt, "Adresse point d'entree Prg MikroC = %x%x h mutiplie 2 soit %04X  ou % 5u decimal \r\n" ,(int)c1,(int)c2,k,k);
 UART1_Write_Text(txt);
  PORTE.F1 =1;
 txt=&TEXTE[0];
 CRam=&CRam1[0];

 L0=Get_Fosc_kHz();
 UART1_Write_CText("Freq kHz= ");
 LongToStr(L0, CRam1);
 UART1_Write_Text(CRam1);
 CRLF1();

 Nokia_Init_Lcd();
 Delay_ms(300);
 Drapeaux.Lcd=1;
 Nokia_Clear();



 Nokia_Pos_Lig_Col(1,1,2);
 strConstRamCpy(txt, (const code char *)"Mikroc Pro 6.62");
 Write_String(txt);
 redirige_RS232(1,txt);
 Nokia_Pos_Lig_Col(2,1,2);
 strConstRamCpy(txt,(const code char *)"Platine 18F4685 ");
 Write_String(txt);
 redirige_RS232(1,txt);
 Nokia_Pos_Lig_Col(3,1,2);
 strConstRamCpy(txt,(const code char *) "With Bootloader.");
 Write_String(txt);
 redirige_RS232(1,txt);
 Nokia_Pos_Lig_Col(4,1,2);
 strConstRamCpy (txt,(const code char *)"RTC DS1307 I2C ");
 Write_String(txt);
 redirige_RS232(1,txt);
 Nokia_Pos_Lig_Col(5,1,2);
 strConstRamCpy (txt,(const code char *) "Paulfjujo@freefr");

 Write_String(txt);
 redirige_RS232(1,txt);
 Delay_ms(3000);


 Drapeaux.Lcd=1;
 Nokia_Clear();
#line 1228 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 CRLF1();
 UART1_Write_CText("Test Sinus avec Print Ram Video  \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 for (i=0;i<96;i++) Nokia_Put_Pixel(i,32+(int)(sin((i+j)*3.14159/30)*30),1) ;
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 UART1_Write_CText("Test avec Bitmap paulfjujo \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 Nokia_Image_96x64(paulfjujo);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 UART1_Write_CText("Test avec Bitmap MikroC_Everywhere_95x64 \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 Nokia_Image_96x64(MikroC_Everywhere_96x64);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 UART1_Write_CText("Test avec Bitmap image_MikroE_96x64 \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 Nokia_Image_96x64(image_MikroE_96x64);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 UART1_Write_CText("Test quadrillage  \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 for (i=0;i<96;i=i+12) Nokia_Line(i,0,i,63,1);
 for (i=0;i<64;i=i+8) Nokia_Line(0,i,95,i,1);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 UART1_Write_CText("Test Diagonales \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 Nokia_Line(1,1,94,63,1);
 Nokia_Line(1,63,94,1,1);
 Nokia_Line(48,1,48,63,1);
 Nokia_Line(1,32,94,32,1);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);
#line 1300 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 UART1_Write_CText("\"Nokia_CText_5x7(L,C,*Rom text\" Mode 8L de 16 cars \r\n");
 Nokia_Clear();
 Nokia_CText_5x7(1,1,"Mode 8L x 16 car");
 Nokia_CText_5x7(2,1,"2em ligne......2");
 Nokia_CText_5x7(3,1,"3em ligne      3");
 Nokia_CText_5x7(4,1,"4em ligne      4");
 Nokia_CText_5x7(5,1,"5em ligne      5");
 Nokia_CText_5x7(6,1,"6em ligne      6");
 Nokia_CText_5x7(7,1,"7em ligne      7");
 Nokia_CText_5x7(8,1,"8em ligne......8");
 Delay_ms(2000);

 UART1_Write_CText("\"Nokia_CText_8x7(L,C,*Rom txt\" Mode 8L de 12 cars \r\n");
 Nokia_Clear();
 Nokia_CText_8x7(1,1,"8Lines x 12C") ;
 Nokia_CText_8x7(2,1,"2em ligne 2 ");
 Nokia_CText_8x7(3,1,"3em LIGNE 3 ");
 Nokia_CText_8x7(4,1,"4em ligne 4 ");
 Nokia_CText_8x7(5,1,"5em ligne 5 ");
 Nokia_CText_8x7(6,1,"6em ligne 6 ");
 Nokia_CText_8x7(7,1,"7em ligne 7 ");
 Nokia_CText_8x7(8,1,"8em ligne 8 ");
 Delay_ms(2000);

 Ligne18Cars=1;

 UART1_Write_CText("test \"Nokia_Write_Char_AT(L,C,char)\" mode 8L de 18 cars \r\n");
 UART1_Write_CText("avec Flag Ligne18cars=1\r\n");
 Nokia_Clear();
 for(j=0;j<8;j++)
 {
 Nokia_Pos_Lig_Col(j+1,1,2);
 for (i=0;i<19;i++)
 {
 Nokia_Write_Char_At(j+1,i,(i % 10) + 48);
 }
 Delay_ms(50);
 }
 Delay_ms(3000);
 Ligne18Cars=0;

 UART1_Write_CText("3 rectangles \r\n");
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 Nokia_Rect (1,1,95,63,1);
 Nokia_Rect (8,8,80,56,1);
 Nokia_Rect (16,16,72,48,1);
 Nokia_Print_Ram_Video();
 Delay_ms(2000);

 Nokia_Clear();
 Nokia_Raz_Ram_Video();
 CRLF1();
 Aide();
 CRLF1();
 Delay_ms(3000);
 Nokia_Clear();
 Nokia_Raz_Ram_Video();
#line 1369 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 UART1_Write_CText("\n\r ATTENTION : SOFTWARE I2C Init :  ");
 UART1_Write_CText(" SCL =RB6   SDA=RB7\n\r ");

 Soft_I2C_Init ();
#line 1376 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 Delay_ms(1000);

 if (INIT_RTC ==0)
 {
 UART1_Write_CText("\n\rRB1=0,donc Init DS1307 par defaut au 25 avril 2016  16H59 \r\n ");
 Init_DS1307();
 }
 else
 {
 UART1_Write_CText("\n\rRB1=1, donc Lecture Date Time du RTC DS1307 \r\n ");
 }
 Drapeaux.Lcd=0;
 UART1_Write_CText(" Read RTC TIME\r\n ");

 Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Drapeaux.Lcd=1;
 Display_Time(Seconde, Minute, Heure);
 Display_Date(week_day, day, Mois, Annee);
 Delay_ms(2000);

 UART1_Write_CText( "\r\nInit Interrupts UART \r\n ");

 INTCON=0;
 RCIE_bit=1;
 UnCar=RCREG;
 PEIE_bit=1;
 GIE_bit=1;

 j=0;
 Drapeaux.Store=0;


 i=0;
 octet=Read_Byte_from_24LC512(i);
 k=octet<<8;
 i++;
 octet=Read_Byte_from_24LC512(i);
 Index=k+(int) octet;
 UART1_Write_CText( " Index 24LC512= ");
 txt=TEXTE;
 WordToStr(Index, txt);
 UART1_Write_Text(txt);
 CRLF1();

 i1=0;
 Index1=0;
 buffer1[0]=0;
 txt=TEXTE;

 Drapeaux.See=0;
 Drapeaux.Lcd=1;
 Nokia_Clear();

 Nokia_Erase_Line(4);
 Nokia_Pos_Lig_Col(4,1,2);
 strConstRamCpy( txt,(const code char *)"ADC0= ");
 Write_String(txt);
 Nokia_Erase_Line(6);
 Nokia_Pos_Lig_Col(6,1,2);
 strConstRamCpy( txt,(const code char *) "ADC1= ");
 Write_String(txt);
 Delay_ms(3000);


 while(1)
 {
 Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Drapeaux.Lcd=1;


 Nokia_Pos_Lig_Col(1,1,2);
 Display_Time(Seconde,Minute, Heure);
 Nokia_Pos_Lig_Col(2,1,2);
 Display_Date( week_day, day, Mois, Annee) ;

 Drapeaux.Lcd=0;
 UART1_Write_CText( " ADC0= ");
 txt=TEXTE;
 M0 = My_ADC_Read(0) ;
 WordToStr(M0, txt);
 Drapeaux.Lcd=1;
 Nokia_Pos_Lig_Col(4,6,2);
 Write_String(txt);
 redirige_RS232(0,txt);
 Drapeaux.Lcd=0;
 UART1_Write (';');
 Drapeaux.Lcd=1;
 Bargraph (M0 ,5) ;

  PORTE.F1 =!  PORTE.F1 ;

 txt=TEXTE;
 UART1_Write_CText( " ADC1= ");
 txt=TEXTE;
 M1 = My_ADC_Read(1) ;
 WordToStr(M1, txt);
 Drapeaux.Lcd=1;
 Nokia_Pos_Lig_Col(6,6,2);
 Write_String(txt);
 redirige_RS232(0,txt);
 Bargraph (M1 ,7) ;

 j++;
 if (j>1023)j=0;
 if(Drapeaux.Store==1) j=Index/64;
 Bargraph (j ,8) ;
 Drapeaux.Lcd=0;

 WordToStr(j, txt);
 Drapeaux.Lcd=1;
 Nokia_Pos_Lig_Col(8,6,2);
 Write_String(txt);


 if (Drapeaux.Store==0) CRLF1();


 if (Drapeaux.Store==1)
 {
 UART1_Write( 9 );
 Drapeaux.Lcd=1;
 CRam=CRam1;
 Nokia_Pos_Lig_Col(2,0,2);
 strConstRamCpy( CRam,(const code char *)"Next Idx=  ");
 WordToStr(Index,CRam+11);
 Write_String(CRam);
 redirige_RS232(1,CRam);
 octet=M1 >> 8;
 Write_Byte_To_24LC512(Index,octet);
 Delay_ms(10);
 Index++;
 octet= (M1 & 0x00FF);
 Write_Byte_To_24LC512(Index,octet);
 Delay_ms(10);
 Index++;
 Save_Index_24LC512();
 }



 if( Drapeaux.Full==1)
 {
 UART1_Write_Text( buffer1);
 CRLF1();

 if ((buffer1[0]=='A') && (buffer1[1]=='I')&& (buffer1[2]=='D')&& (Index1==3))
 {
 Aide();
 buffer1[0]=0;
 Delay_ms(2000);
 CRLF1();
 }



 if ((buffer1[0]=='U') && (buffer1[19]=='#'))
 {
 MAJ_RTC();
 Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Transform_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);
 Display_Time(Seconde, Minute, Heure);
 Display_Date(week_day, day, Mois, Annee);
 buffer1[0]=0;
 }
#line 1582 "C:/_MikroC/_MesProjets_MikroC/_18F4685_Platine_Nokia_40Mhz_2016/18F4685_Platine_with_Lib_Nokia_24LC512_40Mhz_160426.c"
 if ((buffer1[0]=='R') && (buffer1[1]=='A') && (buffer1[2]=='Z')&& (Index1==3))
 {
 UART1_Write_CText("\r\nRAZ Idx saveEeprom\r\n");
 Index=0;
 Save_Index_24LC512();
 }

 if ((buffer1[0]=='S') && (buffer1[1]=='T') && (buffer1[2]=='A') && (Index1==3))
 {
 UART1_Write_CText("\r\nSTART saveEeprom\r\n");
 Drapeaux.Lcd=1;
 CRam=CRam1;
 Nokia_Pos_Lig_Col(3,0,2);
 strConstRamCpy(CRam,"START saveEeprom");
 Write_String(CRam);
 Drapeaux.Store=1;
 Index++;
 Save_Date_Time_To_24LC512();
 Index++;
 }

 if ((buffer1[0]=='H') && (buffer1[1]=='A') && (buffer1[Z]=='L')&& (Index1==3))
 {
 Drapeaux.Lcd=1;
 CRam=CRam1;
 Nokia_Pos_Lig_Col(3,0,2);
 strConstRamCpy(CRam,"HALT sav/Eeeprom");
 Write_String(CRam);
 redirige_RS232(1,CRam);
 Drapeaux.Store=0;
 Save_Date_Time_To_24LC512();
 Index=Index+6;
 Save_Index_24LC512();
 }
 if ((buffer1[0]=='R') && (buffer1[1]=='E') && (buffer1[2]=='L')&& (Index1==3))
 {
 Drapeaux.Store=0;
 Drapeaux.Lcd=1;
 CRam=CRam1;
 Nokia_Pos_Lig_Col(3,0,2);
 strConstRamCpy( CRam,(const code char *)"Relect. EEprom. ");
 Write_String(CRam);
 Drapeaux.Lcd=0;

 octet=Read_Byte_from_24LC512(0);
 k=octet<<8;
 octet=Read_Byte_from_24LC512(1);
 Index=k+octet;
 Index++;
 CRam=CRam1;
 WordToStr(Index,CRam);
 UART1_Write_Text(CRam);
 CRLF1();
 CRam=CRam1;
 for (i=2;i<8;i++)
 {
 octet=Read_Byte_from_24LC512(i);

 ByteToHex(octet,CRam);
 UART1_Write_Text(CRam);
 }
 CRLF1();
 CRam=CRam1;
 for(i=8;i<=Index;i++)
 {
 k=(i-6)>>1;
 WordToStr(k+1,CRam);
 UART1_Write_Text(CRam); UART1_Write( 9 );
 octet=Read_Byte_from_24LC512(i);
 i++;
 M1= (Read_Byte_from_24LC512(i)<<8 ) + octet;
 WordToStr(M1,CRam);
 UART1_Write_Text(CRam); UART1_Write( 9 );
 F1=(float)M1*0.0048828125;
 Float2Ascii (F1, CRam1,3);
 UART1_Write_Text(CRam1);
 CRLF1();
 }
 }




 if ((buffer1[0]=='D') && (buffer1[1]=='U')&& (buffer1[2]=='M')&& (Index1==5))
 {
 GIE_bit=0;
 PageFlash=atoi(buffer1+3);
 UART1_Write_CText("\r\nDUMP FLASH PIC page : ");
 UART1_Write_Text(buffer1+3);
 txt=TEXTE;
 if ((PageFlash<96) && (PageFlash>=0))
 {
 L1=(unsigned long)PageFlash << 10;
 L1=(unsigned long)PageFlash *1024;
 UART1_Write_CText("  soit  partir de : ");
 LongWordToHex(L1,txt);
 UART1_Write_Text(txt); CRLF1();
 for (ir=0;ir<1024;ir++)
 {
 if ((ir%16)==0)
 {
 CRLF1();
 WordToHex(ir,txt);
 UART1_Write_Text(txt);UART1_Write(' ');
 }
 L1=((long)PageFlash << 10) + (long)ir;

 c0 = FLASH_Read(L1) ;
 Delay_ms(25);
 ByteToHex(c0, txt);
 UART1_Write_Text(txt);UART1_Write(' ');
 }
 UART1_Write_CText("\r\n  Flash read 64 bytes\r\n");
 Nokia_Raz_Ram_Video();
 L1=0x017C00+0x0003C0;
 UART1_Write_CText("  soit  partir de : ");
 LongWordToHex(L1,txt);
 UART1_Write_Text(txt); CRLF1();
 FLASH_Read_N_Bytes(L1,Ram_Video,64);
 for (ir=0;ir<64;ir++)
 {
 if ((ir%16)==0)
 {
 CRLF1();
 Delay_ms(100);
 WordToStr(ir,txt);
 UART1_Write_Text(txt);UART1_Write(' ');
 }
 ByteToHex(Ram_Video[ir], txt);
 UART1_Write_Text(txt);UART1_Write(' ');
 }
 Nokia_Raz_Ram_Video();
 CRLF1();
 }
 else
 UART1_Write_CText("\r\nERROR Cde DUMP, format :  DUM00<CR>  .. DM95<CR>\r\n ");
 CRLF1();
 GIE_bit=1;

 }



 buffer1[0]=0;
 Drapeaux.Full=0;
 Index1=0;
 i1=0;
 Delay_ms(1000);
 }



 }
}
