
//#define EEPROM_64K_ADR 0xA0

   // ******* EEPROM 64K  ******************
void Write_Byte_To_24LC512(unsigned int Adr, unsigned char cx) ;
unsigned char Read_Byte_from_24LC512(unsigned int Adr) ;
void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg);
void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg) ;
void Save_Date_Time_To_24LC512(void) ;

// ******* EEPROM 64K  ******************
void Write_Byte_To_24LC512(unsigned int Adr, unsigned char cx)
{
I2C1_Start();
I2C1_Wr(EEPROM_64K_ADR );      // write
I2C1_Wr(Adr>>8);    // send data (data to be written)
I2C1_Wr(Adr& 0x00FF);
I2C1_Wr(cx);    // send data (data to be written)
I2C1_Stop();
Delay_ms(5);
 }

unsigned char Read_Byte_from_24LC512(unsigned int Adr)
{
unsigned char c3;
I2C1_Start();
I2C1_Wr(EEPROM_64K_ADR );  // write
I2C1_Wr(Adr>>8);    // send data (data to be written)
I2C1_Wr(Adr&0x00FF);
I2C1_Stop();
I2C1_Start();    // I2C1_Repeated_Start();
Delay_ms(1);
I2C1_Wr(EEPROM_64K_ADR+1 );  // Read
c3=I2C1_Rd(0u);    // data to be read)
I2C1_Stop();
return c3;
}

void Read_Msg_From_24LC512(unsigned char *t, unsigned int Adr, int Lg)
{int i;
  for (i=0;i<Lg;i++)
  {
   *(t+i)=Read_Byte_from_24LC512(Adr+i);
    Delay_ms(1);
  }
 }

void Write_Msg_To_24LC512(unsigned char *t, unsigned int Adr, int lg)
{ int i;
  for (i=0;i<lg;i++)
  {
   Write_Byte_To_24LC512(Adr+i, *(t+i)) ;
   Delay_ms(5);   // delay minimum !!
  }
}

void Save_Date_Time_To_24LC512()
{
GIE_bit=0;
 Read_Time(&Seconde,&Minute,&Heure,&week_day,&day,&Mois,&Annee);      // read time from RTC(DS1307)
 Write_Byte_To_24LC512(Index,Mois); Index++;
  Write_Byte_To_24LC512(Index,day); Index++;
   Write_Byte_To_24LC512(Index,Heure);  Index++;
    Write_Byte_To_24LC512(Index,Minute);   Index++;
        Write_Byte_To_24LC512(Index,Seconde);   Index++;
         Write_Byte_To_24LC512(Index,13);
        GIE_bit=1;
}
